
;--------------------------------------------------------------------
function ccf_cl_to_ccf_header, cl, cntl_header = cntl_header

	header = ccf_create_new_header()
	header.name = cl.name
	header.set_no = cl.set_no
	header.rev_no = cl.rev_no

	if (cl.test eq 0 and cl.safe eq 1) then tmp = 'SAFE' $
	else tmp = 'TEST'
	header.status = tmp
	header.range = cl.range

	header.creator = cl.creator
	if (cl.cdate eq 'NOW') then begin
		command = 'date "+%Y-%m-%dT%H:%M:%S"'
		spawn, command, result
		header.cdate = result[0]
	endif else header.cdate = cl.cdate

	header.fmtver = cl.fmtver
	header.comment = cl.description

	cntl_header = {name:cl.name, $
		set_no:cl.set_no, $
		rev_no:cl.rev_no, $
		test:cl.test, $
		safe:cl.safe, $
		FISAS:cl.fisas, $
		fis01:cl.fis01, $
		fis02:cl.fis02, $
		fis03:cl.fis03, $
		range:cl.range, $
		description:cl.description}

	return, header
end


;--------------------------------------------------------------------
function CCF_Edit_create_formats, cl, $
	group_leader = group_leader, $
	cntl_entry = cntl_entry, header_entry = header_entry, $
	adding_entry = adding_entry, ccf_list = ccf_list, $
	title = title, ERROR = error

error = !SUCCEED

base = WIDGET_BASE(/COLUMN, /modal, group_leader = group_leader, $
	title = title)

fbase = WIDGET_BASE(base, /COLUMN, SPACE=0)

if (keyword_set(adding_entry)) then begin
	if (n_elements(ccf_list) eq 0) then begin
		message, 'CCF_LIST must be specified.', /cont
		error = !FAIL
		return, !FAIL
	endif

	sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
	CCF_DROPLIST = widget_droplist(sbase, $
		value = ccf_list, uvalue = ccf_list)
endif

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='CCF_NAME', /ALIGN_LEFT,   XSIZE=100)
CCF_NAME = WIDGET_TEXT(sbase, VALUE=cl.NAME, $
	XSIZE=8, UVALUE='NAME')

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='SET_NO',   /ALIGN_LEFT,   XSIZE=100)
SET_NO = WIDGET_TEXT(sbase, VALUE=STRING(FORMAT='(I4)', cl.SET_NO, /PRINT), $
	XSIZE=4)

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='REV_NO',   /ALIGN_LEFT,   XSIZE=100)
REV_NO = WIDGET_TEXT(sbase, VALUE=STRING(FORMAT='(I4)', cl.REV_NO, /PRINT), $
	XSIZE=4)

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='CCF Status', /ALIGN_LEFT,   XSIZE=100)
TEST = WIDGET_COMBOBOX(sbase, VALUE=['N', 'Y'], UVALUE='TEST', XSIZE=40)
label = WIDGET_LABEL(sbase, VALUE='TEST',     /ALIGN_LEFT,   XSIZE=40)
WIDGET_CONTROL, TEST, SET_COMBOBOX_SELECT=cl.TEST
SAFE = WIDGET_COMBOBOX(sbase, VALUE=['N', 'Y'], UVALUE='SAFE', XSIZE=40)
label = WIDGET_LABEL(sbase, VALUE='SAFE',     /ALIGN_LEFT,   XSIZE=40)
WIDGET_CONTROL, SAFE, SET_COMBOBOX_SELECT=cl.SAFE

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='Applied for',     /ALIGN_LEFT,   XSIZE=100)
FISAS = WIDGET_COMBOBOX(sbase, VALUE=['N', 'Y'], UVALUE='FISAS', XSIZE=40)
WIDGET_CONTROL, FISAS, SET_COMBOBOX_SELECT=cl.FISAS
label = WIDGET_LABEL(sbase, VALUE='FISAS',     /ALIGN_LEFT,   XSIZE=40)

FIS01 = WIDGET_COMBOBOX(sbase, VALUE=['N', 'Y'], UVALUE='FIS01', XSIZE=40)
WIDGET_CONTROL, FIS01, SET_COMBOBOX_SELECT=cl.FIS01
label = WIDGET_LABEL(sbase, VALUE='FIS01',     /ALIGN_LEFT,   XSIZE=40)

FIS02 = WIDGET_COMBOBOX(sbase, VALUE=['N', 'Y'], UVALUE='FIS02', XSIZE=40)
WIDGET_CONTROL, FIS02, SET_COMBOBOX_SELECT=cl.FIS02
label = WIDGET_LABEL(sbase, VALUE='FIS02',     /ALIGN_LEFT,   XSIZE=40)

FIS03 = WIDGET_COMBOBOX(sbase, VALUE=['N', 'Y'], UVALUE='FIS03', XSIZE=40)
WIDGET_CONTROL, FIS03, SET_COMBOBOX_SELECT=cl.FIS03
label = WIDGET_LABEL(sbase, VALUE='FIS03',     /ALIGN_LEFT,   XSIZE=40)

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='Valid Range',   /ALIGN_LEFT,   XSIZE=100)
label = WIDGET_LABEL(sbase, VALUE='From',   /ALIGN_LEFT,   XSIZE=30)
RANGE_FROM = WIDGET_TEXT(sbase, VALUE=STRMID(cnv_aftime(cl.RANGE[0]), 0, 20), /EDITABLE, XSIZE=20)
label = WIDGET_LABEL(sbase, VALUE='To',   /ALIGN_LEFT,   XSIZE=30)
RANGE_TO = WIDGET_TEXT(sbase, VALUE=STRMID(cnv_aftime(cl.RANGE[0]), 0, 20), /EDITABLE, XSIZE=20)

if (keyword_set(header_entry) or keyword_set(adding_entry)) then begin
	sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
	label = WIDGET_LABEL(sbase, VALUE='Creator', /ALIGN_LEFT,   XSIZE=100)
	CREATOR = WIDGET_TEXT(sbase, VALUE=cl.creator, $
		/EDITABLE, XSIZE=10, UVALUE='CREATOR')

	sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
	label = WIDGET_LABEL(sbase, VALUE='Create date', /ALIGN_LEFT,   XSIZE=100)
	CDATE = WIDGET_TEXT(sbase, VALUE=cl.cdate, $
		/EDITABLE, XSIZE=35, UVALUE='CDATE')

	sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
	label = WIDGET_LABEL(sbase, VALUE='FMT ver.', /ALIGN_LEFT,   XSIZE=100)
	FMTVER = WIDGET_TEXT(sbase, VALUE=cl.fmtver, $
		/EDITABLE, XSIZE=8, UVALUE='FMTVER')
endif

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='Description',   /ALIGN_LEFT,   XSIZE=100)
dbase = WIDGET_BASE(sbase, /COLUMN, $
	XSIZE=315, X_SCROLL_SIZE=320, YSIZE=165, Y_SCROLL_SIZE=100, /SCROLL)
DESCR = WIDGET_TEXT(dbase, VALUE=cl.DESCRIPTION, $
	/EDITABLE, UVALUE='DESC', XSIZE=80, YSIZE=10)

sbase = WIDGET_BASE(fbase, /ROW, FRAME=1)
label = WIDGET_LABEL(sbase, VALUE='Data',   /ALIGN_LEFT,   XSIZE=100)
dbase = WIDGET_BASE(sbase, /COLUMN, $
	XSIZE=315, X_SCROLL_SIZE=320, YSIZE=165, Y_SCROLL_SIZE=100, /SCROLL)
DATA = WIDGET_TEXT(dbase, VALUE = '', UVALUE='DATA', XSIZE=80, YSIZE=20)

mbase = WIDGET_BASE(base, /ROW)

if (keyword_set(header_entry)) then begin
	okbtn_label = 'Make new CCF'
endif else begin
	okbtn_label = 'OK'
endelse

cnbtn = WIDGET_BUTTON(mbase, VALUE='Cancel', XSIZE=100, UVALUE='Cancel')
okbtn = WIDGET_BUTTON(mbase, VALUE=okbtn_label,     XSIZE=100, UVALUE='OK')

if (keyword_set(header_entry)) then begin
	ids = { base:base, $
		CCF_NAME:CCF_NAME, SET_NO:SET_NO, REV_NO:REV_NO, $
		TEST:TEST, SAFE:SAFE, FISAS:FISAS, FIS01:FIS01, FIS02:FIS02, FIS03:FIS03, $
		RANGE_FROM:RANGE_FROM, RANGE_TO:RANGE_TO, $
		CREATOR:CREATOR, CDATE:CDATE, FMTVER:FMTVER, $
		DESCR:DESCR, DATA:DATA}
endif else if (keyword_set(cntl_entry)) then begin
	ids = { base:base, $
		CCF_NAME:CCF_NAME, SET_NO:SET_NO, REV_NO:REV_NO, $
		TEST:TEST, SAFE:SAFE, FISAS:FISAS, FIS01:FIS01, FIS02:FIS02, FIS03:FIS03, $
		RANGE_FROM:RANGE_FROM, RANGE_TO:RANGE_TO, DESCR:DESCR, DATA:DATA}
endif else if (keyword_set(adding_entry)) then begin
	ids = { base:base, $
		CCF_DROPLIST:CCF_DROPLIST, $
		CCF_NAME:CCF_NAME, SET_NO:SET_NO, REV_NO:REV_NO, $
		TEST:TEST, SAFE:SAFE, FISAS:FISAS, FIS01:FIS01, FIS02:FIS02, FIS03:FIS03, $
		RANGE_FROM:RANGE_FROM, RANGE_TO:RANGE_TO, $
		CREATOR:CREATOR, CDATE:CDATE, FMTVER:FMTVER, $
		DESCR:DESCR, DATA:DATA}
endif else begin
	error = !FAIL
	return, !FAIL
endelse

return, ids

end


;--------------------------------------------------------------------
PRO CCF_Edit_Header_Entry_event, ev

	widget_control, ev.top, get_uvalue = ccee_strg
	WIDGET_CONTROL, ev.id, GET_UVALUE=uvalue

if (n_elements(uvalue) ge 2) then begin

; Event from CCF_DROPLIST 
; ------------------------------
	if (ev.id eq ccee_strg.CCF_DROPLIST) then begin

		widget_control, ccee_strg.CCF_DROPLIST, get_uvalue = tmp
		ccf_filename = tmp[ev.index]

		widget_control, /hourglass
		ccf_data = ccf_read_ccf_file(ccf_filename, header = header)

		widget_control, ccee_strg.CCF_NAME, set_value = header.name
		widget_control, ccee_strg.SET_NO, $
			set_value = string(header.set_no, format = '(i4)')
		widget_control, ccee_strg.REV_NO, $
			set_value = string(header.rev_no, format = '(i4)')
		widget_control, ccee_strg.TEST, $
			set_combobox_select = header.status eq 'TEST'?1:0
		widget_control, ccee_strg.SAFE, $
			set_combobox_select = header.status eq 'SAFE'?1:0
		from = header.range[0]
		widget_control, ccee_strg.RANGE_FROM, $
			set_value = strmid(cnv_aftime(from), 0, 20)
		to = header.range[1]
		widget_control, ccee_strg.RANGE_To, $
			set_value = strmid(cnv_aftime(to), 0, 20)
		widget_control, ccee_strg.CREATOR, set_value = header.creator
		widget_control, ccee_strg.CDATE, set_value = header.cdate
		widget_control, ccee_strg.FMTVER, set_value = header.fmtver

		; Split multiple line description separated by ^J.
		; ------------------------------
		cmtstr = strsplit(header.comment, string(10B), /extract)
		widget_control, ccee_strg.DESCR, set_value = cmtstr ;header.comment

		defs = ccf_data_defs(ccf_data, error = error)
		if (error eq !FAIL) then return
		widget_control, ccee_strg.DATA, set_value = defs

	endif

	return

endif

	CASE uvalue OF
		'Cancel' : begin
			*ccee_strg.exit_status = 1B
			WIDGET_CONTROL, ev.top, /DESTROY
		end

		'OK'     : begin

			widget_control, ccee_strg.CCF_NAME, get_value = name
			name = name[0]
			(*ccee_strg.cl).name = name

			widget_control, ccee_strg.SET_NO, get_value = set_no
			set_no = fix(set_no[0])
			(*ccee_strg.cl).set_no = set_no

			widget_control, ccee_strg.REV_NO, get_value = rev_no
			rev_no = fix(rev_no[0])
			(*ccee_strg.cl).rev_no = rev_no

			str = widget_info(ccee_strg.TEST, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).TEST  = 1 $
			else (*ccee_strg.cl).TEST  = 0

			str = widget_info(ccee_strg.SAFE, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).SAFE  = 1 $
			else (*ccee_strg.cl).SAFE  = 0

			str = widget_info(ccee_strg.FISAS, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FISAS  = 1 $
			else (*ccee_strg.cl).FISAS  = 0

			str = widget_info(ccee_strg.FIS01, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FIS01  = 1 $
			else (*ccee_strg.cl).FIS01  = 0

			str = widget_info(ccee_strg.FIS02, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FIS02  = 1 $
			else (*ccee_strg.cl).FIS02  = 0

			str = widget_info(ccee_strg.FIS03, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FIS03  = 1 $
			else (*ccee_strg.cl).FIS03  = 0

			widget_control, ccee_strg.RANGE_FROM, get_value = from
			from = strtrim(from[0], 2)
			if ( stregex(from, '[/:]') ne 4 ) then begin
				message, 'Invalid format: Valid Range (From)', /cont
				return
			endif
			from = cnv_aftime(from)
			if (from lt 1d-4) then from = 0D
			(*ccee_strg.cl).RANGE[0] = from

			widget_control, ccee_strg.RANGE_To, get_value = to
			to = strtrim(to[0], 2)
			if ( stregex(to, '[/:]') ne 4 ) then begin
				message, 'Invalid format: Valid Range (To)', /cont
				return
			endif
			to = cnv_aftime(to)
			if (to lt 1d-4) then to = 0D
			(*ccee_strg.cl).RANGE[1] = to

			widget_control, ccee_strg.CREATOR, get_value = tmp
			tmp = tmp[0]
			(*ccee_strg.cl).creator = tmp

			widget_control, ccee_strg.CDATE, get_value = tmp
			tmp = tmp[0]
			(*ccee_strg.cl).cdate = tmp

			widget_control, ccee_strg.FMTVER, get_value = tmp
			tmp = tmp[0]
			(*ccee_strg.cl).fmtver = tmp

			widget_control, ccee_strg.DESCR, get_value = descr
			; Concatenate multiple line comments with a separator charactor of ^J.
			; ------------------------------
			cmtstr = ''
			for i = 0, n_elements(descr)-1 do begin
				cmtstr = cmtstr + descr[i] + string(10B)
			endfor
			cmtstr = strmid(cmtstr, 0, strlen(cmtstr)-1)
			(*ccee_strg.cl).description = cmtstr

			if ( $
				ccf_validate_header(ccf_cl_to_ccf_header(*ccee_strg.cl)) eq !FAIL $
			) then return

			if ((*ccee_strg.cl).description eq '') then begin
				message, 'Description is empty.', /cont
				return
			endif

			WIDGET_CONTROL, ev.top, /DESTROY
		end

      ELSE     : 
   ENDCASE

RETURN
END

;--------------------------------------------------------------------
function CCF_Edit_Header_Entry, top_id, $
	ccf_data = ccf_data, cntl_header = cntl_header, $
	ccf_list = ccf_list

	if (n_elements(ccf_list) eq 0) then begin

; Creating New CCF
; ------------------------------
		spawn, 'whoami', creator, err, exit = stat
		if (stat ne 0) then creator = ''

		cl = { $
			name: '', $
			set_no: 1U, $
			rev_no: 1U, $
			test:	1U, $
			safe: 0U, $
			FISAS: 1U, $
			FIS01: 1U, $
			FIS02: 1U, $
			FIS03: 1U, $
			range: dblarr(2), $
			creator: creator, $
			cdate: 'NOW', $
			fmtver: strtrim(string(ccf_current_fmtver())), $
			description: '' $
		}

		title = 'Specify New CCF header'

		ids = CCF_Edit_create_formats(cl, $
			group_leader = top_id, $
			/header_entry, $
			title = title, ERROR = error)
		if (error eq !FAIL) then return, !FAIL

		widget_control, ids.CCF_NAME, editable = 1B
		widget_control, ids.SET_NO, editable = 1B
		widget_control, ids.REV_NO, editable = 1B

		data_type = ccf_data_defs(ccf_data, error = error)
		if (error eq !FAIL) then return, !FAIL
		widget_control, ids.DATA, set_value = data_type

		cl = ptr_new(cl)
		exit_status = ptr_new(0B)

; Create data storage.
; ------------------------------
		ccee_strg = { $
			cl:cl, $
			CCF_NAME:ids.CCF_NAME, $
			SET_NO:ids.SET_NO, $
			REV_NO:ids.REV_NO, $
			TEST:ids.TEST, $
			SAFE:ids.SAFE, $
			FISAS:ids.FISAS, $
			FIS01:ids.FIS01, $
			FIS02:ids.FIS02, $
			FIS03:ids.FIS03, $
			RANGE_FROM:ids.RANGE_FROM, $
			RANGE_TO:ids.RANGE_TO, $
			CREATOR:ids.CREATOR, $
			CDATE:ids.CDATE, $
			FMTVER:ids.FMTVER, $
			DESCR:ids.DESCR, $
			DATA:ids.DATA, $
			exit_status:exit_status $
		}

	endif else begin

; Adding CCF
; ------------------------------

		widget_control, /hourglass
		ccf_data = ccf_read_ccf_file(ccf_list[0], header = header)

		if (header.status eq 'TEST') then begin
			test = 1U & safe = 0U
		endif else begin
			test = 0U & safe = 1U
		endelse
		cl = { $
			name: header.name, $
			set_no: header.set_no, $
			rev_no: header.rev_no, $
			test:	test, $
			safe: safe, $
			FISAS: 1U, $
			FIS01: 1U, $
			FIS02: 1U, $
			FIS03: 1U, $
			range: header.range, $
			creator: header.creator, $
			cdate: header.cdate, $
			fmtver: header.fmtver, $
			description: header.comment $
		}

		title = 'Choose and Confirm CCF header and Specify CNTL info.'

		ids = CCF_Edit_create_formats(cl, $
			group_leader = top_id, $
			/adding_entry, ccf_list = ccf_list, $
			title = title, ERROR = error)

		cl = ptr_new(cl)
		exit_status = ptr_new(0B)

; Create data storage.
; ------------------------------
		ccee_strg = { $
			cl:cl, $
			CCF_DROPLIST:ids.CCF_DROPLIST, $
			CCF_NAME:ids.CCF_NAME, $
			SET_NO:ids.SET_NO, $
			REV_NO:ids.REV_NO, $
			TEST:ids.TEST, $
			SAFE:ids.SAFE, $
			FISAS:ids.FISAS, $
			FIS01:ids.FIS01, $
			FIS02:ids.FIS02, $
			FIS03:ids.FIS03, $
			RANGE_FROM:ids.RANGE_FROM, $
			RANGE_TO:ids.RANGE_TO, $
			CREATOR:ids.CREATOR, $
			CDATE:ids.CDATE, $
			FMTVER:ids.FMTVER, $
			DESCR:ids.DESCR, $
			DATA:ids.DATA, $
			exit_status:exit_status $
		}

	endelse

	widget_control, ids.base, set_uvalue = ccee_strg, /no_copy

; show the window
   WIDGET_CONTROL, ids.base, /REALIZE

; wait for events
   XMANAGER, "CCF_Edit_Header_Entry", ids.base, $
		group_leader = top_id

	return_struct = *cl
	ptr_free, cl

	status = *exit_status
	ptr_free, exit_status

	if (status) then begin

		error = !FAIL
		return, !FAIL

	endif else begin

		header = ccf_cl_to_ccf_header(return_struct, $
			cntl_header = cntl_header)

		return, header

	endelse

end


;--------------------------------------------------------------------
function CCF_load_savefile, savfile, ERROR = error

; Reset error status.
error = !SUCCEED

if (savfile eq '') then begin
	error = !FAIL
	return, !values.d_nan
endif

idl_savefile_object = obj_new('idl_savefile', savfile)
if ( not obj_valid(idl_savefile_object) ) then return, !FAIL

member = idl_savefile_object->names()
idl_savefile_object->restore, member[0]
obj_destroy, idl_savefile_object

command = 'return_value = ' + member[0]
stat = execute(command)
if (stat ne 1) then begin
	message, 'Failed executing ' + command, /cont
	error = !FAIL
	return, !values.d_nan
endif

return, return_value

end


;--------------------------------------------------------------------
function CCF_CNTL_Check_Consistency, ccf_filename, cntl, $
	silent = silent

; Load CCF.
; ------------------------------
if (keyword_set(silent)) then begin
	msg_bak = !msg_level
	!msg_level = 1
endif

widget_control, /hourglass
dummy = ccf_read_ccf_file(!CCF_PATH + '/' + ccf_filename, header = header)

if (keyword_set(silent)) then !msg_level = msg_bak


; Search CCF in CNTL.
; ------------------------------
index = where(cntl.name eq header.name and $
	cntl.set_no eq header.set_no and $
	cntl.rev_no eq header.rev_no, count)
if (count eq 0) then begin
	message, 'Cannot find ' + ccf_filename, /cont
	return, !FAIL
endif

;help, cntl[index], /struct

; Check Status.
; ------------------------------
;stat = cntl.test + cntl.safe * 2L

return, !SUCCEED

end


;--------------------------------------------------------------------
function ccf_make_ccf_filename, cl
	return, !CCF_PATH + $
		cl.name + $
		'_' + strmid('00000' + string(cl.set_no, format = '(i0)'), 2, /rev) + $
		'_' + strmid('00000' + string(cl.rev_no, format = '(i0)'), 2, /rev) + $
		'.ccf'

end


;--------------------------------------------------------------------
function ccf_read_data_type, cl

; Read data define header.
; ------------------------------
	ccf_file = ccf_make_ccf_filename(cl)

	cmd = 'grep -n "ENDDEFINE" ' + ccf_file
	spawn, cmd, res, err, exit = stat
	bufsiz = long(repstr(res[0], ':#ENDDEFINE', ''))
	str = strarr(bufsiz)
	openr, lun, ccf_file, /get_lun
	readf, lun, str
	close, lun & free_lun, lun

	s_pos = where(strmid(str, 0, 7) eq '#DEFINE', count)
	if (count ne 1) then begin
		Message, 'No DEFINE or multiple DEFINEs are found.', /cont
		return, '' 
	endif

	e_pos = where(strmid(str, 0, 7) eq '#ENDDEF', count)
	if (count ne 1) then begin
		Message, 'No ENDDEFINE or multiple ENDDEFINEs are found.', /cont
		return, ''
	endif

	str = str[(s_pos+1):(e_pos-1)]
	return, str

end


;--------------------------------------------------------------------
function CCF_CNTL_Split_Table, str

index = strsplit(str)

if (n_elements(index) ge 14) then begin
	return_str = strarr(12)
endif else begin
; A case of that description is blank
	return_str = strarr(11)
endelse

for i = 0, n_elements(return_str)-1 do begin

	if (i lt 9) then begin
		return_str[i] = strmid(str, index[i], index[i+1] - index[i])
	endif else if (i lt 11) then begin

		if (2*(i+1-9)+9 lt n_elements(index)-1) then $
			return_str[i] = strmid(str, index[2*(i-9)+9], $
				index[2*(i+1-9)+9] - index[2*(i-9)+9]) $
		else $
			; A case of that description is blank
			return_str[i] = strmid(str, index[2*(i-9)+9])

	endif else begin
		return_str[i] = strmid(str, index[13])
	endelse

endfor

return, strtrim(return_str, 2)

end

;--------------------------------------------------------------------
;
function CCF_CNTL_Sort_Table, str, sortkey, reverse_order = reverse_order, $
	first_cntl = first_cntl, last_cntl = last_cntl

tablelist = str

; Backup CNTL line.
; ------------------------------
if (keyword_set(first_cntl) or keyword_set(last_cntl)) then begin
	index = where(strmid(tablelist, 0, 5) eq 'CNTL_')
	cntl_str = tablelist[index]
	tablelist[index] = '#'
endif

; Lines following '#' are comment.
; ------------------------------
index = where(strmid(tablelist, 0, 1) ne '#', count)
if (count ne 0) then tablelist = tablelist[index]

; Skip sorting if SORTKEY is not specified or SORTKEY = -1.
; ------------------------------
if (n_elements(sortkey) eq 0) then goto, sort_table_label2
if (sortkey[0] eq -1) then goto, sort_table_label2

; Make sortkey.
; 1. Substitute ":" for field separator to swap fields.
; ------------------------------
tmp2 = strarr(n_elements(tablelist))
for i = 0, n_elements(tablelist) - 1 do begin
	tmp = CCF_CNTL_split_table(tablelist[i])
	tmp2[i] = tmp[0]
	for j = 1, n_elements(tmp)-1 do begin
		tmp2[i] = tmp2[i] + ':' + tmp[j]
	endfor
endfor

; 2. Swap fields to force the sortkey to be the first field.
; ------------------------------
sortstr = swap_fields(tmp2, sortkey, separator = ':')

; Sort the data.
; ------------------------------
index = sort(sortstr)
tablelist = tablelist[index]


sort_table_label2:

if (keyword_set(reverse_order)) then begin
	tablelist = reverse(tablelist)
endif

if (keyword_set(first_cntl)) then begin
	tablelist = [cntl_str, tablelist]
endif
if (keyword_set(last_cntl)) then begin
	tablelist = [tablelist, cntl_str]
endif

return, strtrim(tablelist, 2)

end


;;--------------------------------------------------------------------
;
;; Numeric or string can be acceptable for sort key.
;; ------------------------------
;function CCF_CNTL_Sort_Table_old, str, sortkey, reverse_order = reverse_order, $
;	first_cntl = first_cntl, last_cntl = last_cntl
;
;tablelist = str
;
;; Backup CNTL line.
;; ------------------------------
;if (keyword_set(first_cntl) or keyword_set(last_cntl)) then begin
;	index = where(strmid(tablelist, 0, 5) eq 'CNTL_')
;	cntl_str = tablelist[index]
;	tablelist[index] = '#'
;endif
;
;; Lines following '#' are comment.
;; ------------------------------
;index = where(strmid(tablelist, 0, 1) ne '#', count)
;if (count ne 0) then tablelist = tablelist[index]
;
;; Skip sorting if SORTKEY is not specified or SORTKEY = -1.
;; ------------------------------
;if (n_elements(sortkey) eq 0) then goto, sort_table_label1
;if (sortkey eq -1) then goto, sort_table_label1
;
;; Get sort key type from the first line of the table.
;; ------------------------------
;first_line = tablelist[0]
;first_elm = CCF_CNTL_split_table(first_line)
;
;if ( is_number(first_elm[sortkey]) eq 1 ) then $
;	key = dblarr(n_elements(tablelist)) $
;else key = strarr(n_elements(tablelist)) 
;
;; Make sort key.
;; ------------------------------
;for i = 0, n_elements(tablelist)-1 do begin
;	tmp = CCF_CNTL_split_table(tablelist[i])
;
;	if (n_elements(tmp) le 1) then begin
;
;		if ( is_number(first_elm[sortkey]) eq 1 ) then $
;			key[i] = 0L $
;		else key[i] = ''
;		continue
;
;	endif
;
;	if ( is_number(first_elm[sortkey]) eq 1 ) then $
;		key[i] = double(tmp[sortkey]) $
;	else key[i] = tmp[sortkey]
;
;endfor
;
;; Sort the table.
;; ------------------------------
;index = sort(key)
;tablelist = tablelist[index]
;
;sort_table_label1:
;
;if (keyword_set(reverse_order)) then begin
;	tablelist = reverse(tablelist)
;endif
;
;if (keyword_set(first_cntl)) then begin
;	tablelist = [cntl_str, tablelist]
;endif
;if (keyword_set(last_cntl)) then begin
;	tablelist = [tablelist, cntl_str]
;endif
;
;return, strtrim(tablelist, 2)
;
;end
;

;--------------------------------------------------------------------
function CCF_CNTL_Get_Table, cntl

nc = N_ELEMENTS(cntl)
liststr = strarr(n_elements(cntl))

for ic = 0L, nc - 1 do begin

	; Concatenate multiple line description.
	; Here the dummy separator, two charactors of "^J" is used
	; only for displaying.
	; ------------------------------
	cmtstr = cntl[ic].description
	cmtstr = strsplit(cmtstr, string(10B), /extract)
	tmpstr = ''
	for i = 0, n_elements(cmtstr)-1 do begin
		tmpstr = tmpstr + cmtstr[i] + '^J'
	endfor
	tmpstr = strmid(tmpstr, 0, strlen(tmpstr)-2)

	liststr[ic] = string( $
		cntl[ic].NAME, $
		cntl[ic].SET_NO, $
		cntl[ic].REV_NO, $
		(cntl[ic].TEST gt 0)			?"Y":"N", $
		(cntl[ic].SAFE gt 0)			?"Y":"N", $
		(cntl[ic].FISAS gt 0)			?"Y":"N", $
		(cntl[ic].FIS01 gt 0)			?"Y":"N", $
		(cntl[ic].FIS02 gt 0)			?"Y":"N", $
		(cntl[ic].FIS03 gt 0)			?"Y":"N", $
		(cntl[ic].range[0] eq 0D)	?"Mission Start":	STRMID(cnv_aftime(cntl[ic].RANGE[0]), 0, 20), $
		(cntl[ic].range[1] eq 0D)	?"Mission End":		STRMID(cnv_aftime(cntl[ic].RANGE[1]), 0, 20), $
		strtrim(strmid(tmpstr, 0, 80), 2), $
		format = '(a-8, 2(x, i6), 6(x, a4), 2(x, a-19), x, a-68)' $
		)

endfor

RETURN, strtrim(liststr, 2)

END



;--------------------------------------------------------------------
function CCF_CNTL_Show_Header2, base

sbase = WIDGET_BASE(base, /ROW, SPACE=0)
clabel = [ $
	'CCF NAME', 'SET_NO', 'REV_NO', 'TEST', 'SAFE', $
	'FAS', 'F01', 'F02', 'F03', $
	'Valid From', 'Valid To', $
	'Description']
label = widget_label(sbase, value = $
	string(clabel, $
		format = '(a-8, 2(x, a6), 6(x, a4), 2(x, a-19), x, a-68)') )

RETURN, clabel

END


;--------------------------------------------------------------------
PRO CCF_Cntl_Edit_Entry2_event, ev

;   COMMON CCF_CNTL, cntl, cl
	widget_control, ev.top, get_uvalue = ccee_strg

   WIDGET_CONTROL, ev.id, GET_UVALUE=uvalue

	CASE uvalue OF
		'Cancel' : begin
			*ccee_strg.exit_status = 1B
			WIDGET_CONTROL, ev.top, /DESTROY
		end

		'OK'     : begin

			widget_control, ccee_strg.CCF_NAME, get_value = name
			name = name[0]
			(*ccee_strg.cl).name = name

			widget_control, ccee_strg.SET_NO, get_value = set_no
			set_no = fix(set_no[0])
			(*ccee_strg.cl).set_no = set_no

			widget_control, ccee_strg.REV_NO, get_value = rev_no
			rev_no = fix(rev_no[0])
			(*ccee_strg.cl).rev_no = rev_no

			str = widget_info(ccee_strg.TEST, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).TEST  = 1 $
			else (*ccee_strg.cl).TEST  = 0

			str = widget_info(ccee_strg.SAFE, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).SAFE  = 1 $
			else (*ccee_strg.cl).SAFE  = 0

			str = widget_info(ccee_strg.FISAS, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FISAS  = 1 $
			else (*ccee_strg.cl).FISAS  = 0

			str = widget_info(ccee_strg.FIS01, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FIS01  = 1 $
			else (*ccee_strg.cl).FIS01  = 0

			str = widget_info(ccee_strg.FIS02, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FIS02  = 1 $
			else (*ccee_strg.cl).FIS02  = 0

			str = widget_info(ccee_strg.FIS03, /combobox_gettext)
			if (str EQ 'Y') then (*ccee_strg.cl).FIS03  = 1 $
			else (*ccee_strg.cl).FIS03  = 0

			widget_control, ccee_strg.RANGE_FROM, get_value = from
			from = strtrim(from[0], 2)
			if ( stregex(from, '[/:]') ne 4 ) then begin
				message, 'Invalid format: Valid Range (From)', /cont
				return
			endif
			from = cnv_aftime(from)
			if (from lt 1d-4) then from = 0D
			(*ccee_strg.cl).RANGE[0] = from

			widget_control, ccee_strg.RANGE_To, get_value = to
			to = strtrim(to[0], 2)
			if ( stregex(to, '[/:]') ne 4 ) then begin
				message, 'Invalid format: Valid Range (To)', /cont
				return
			endif
			to = cnv_aftime(to)
			if (to lt 1d-4) then to = 0D
			(*ccee_strg.cl).RANGE[1] = to
			
			widget_control, ccee_strg.DESCR, get_value = descr
			; Concatenate multiple line comments with a separator charactor of ^J.
			; ------------------------------
			cmtstr = ''
			for i = 0, n_elements(descr)-1 do begin
				cmtstr = cmtstr + descr[i] + string(10B)
			endfor
			cmtstr = strmid(cmtstr, 0, strlen(cmtstr)-1)
			(*ccee_strg.cl).description = cmtstr

			WIDGET_CONTROL, ev.top, /DESTROY
		end

      ELSE     : 
   ENDCASE

;print, cl.name
RETURN
END

;--------------------------------------------------------------------
function CCF_Cntl_Edit_Entry2, top_id, index, storage


	cntl = *storage.cntl
	cl = cntl[index]

	nc = N_ELEMENTS(cntl)
	if (index GE nc) then begin
		LMESSAGE, 1, STRING('Invalid Entry number', index, /PRINT), /CONTINUE
		return, -1
	endif

	title = 'Editing CNTL Entries'

	ids = CCF_Edit_create_formats(cl, $
		group_leader = top_id, $
		/cntl_entry, $
		title = title, ERROR = error)

	widget_control, ids.CCF_NAME, editable = 0
	widget_control, ids.SET_NO, editable = 0
	widget_control, ids.REV_NO, editable = 0

 	data_type = ccf_read_data_type(cl)
	widget_control, ids.DATA, set_value = data_type

	cl = ptr_new(cl)
	exit_status = ptr_new(0B)

; Create data storage.
; ------------------------------
	ccee_strg = { $
		cl:cl, $
		CCF_NAME:ids.CCF_NAME, $
		SET_NO:ids.SET_NO, $
		REV_NO:ids.REV_NO, $
		TEST:ids.TEST, $
		SAFE:ids.SAFE, $
		FISAS:ids.FISAS, $
		FIS01:ids.FIS01, $
		FIS02:ids.FIS02, $
		FIS03:ids.FIS03, $
		RANGE_FROM:ids.RANGE_FROM, $
		RANGE_TO:ids.RANGE_TO, $
		DESCR:ids.DESCR, $
		DATA:ids.DATA, $
		exit_status:exit_status $
	}
	widget_control, ids.base, set_uvalue = ccee_strg, /no_copy

; show the window
   WIDGET_CONTROL, ids.base, /REALIZE

; wait for events
   XMANAGER, "CCF_Cntl_Edit_Entry2", ids.base, $
		group_leader = top_id

	return_struct = *cl
	ptr_free, cl

	status = *exit_status
	ptr_free, exit_status

	if (status) then return, -1 $
	else return, return_struct

end



;--------------------------------------------------------------------
PRO ccf_control_panel_cleanup, id

widget_control, id, get_uvalue = storage, /no_copy

; If there is no update on CNTL in the current session,
; delete the backup file.
; ------------------------------
if (*storage.change_flag eq 0B) then begin
	cmd = '/bin/rm ' + storage.backup_cntl_file
	spawn, cmd, res, err, exit = stat
	if (stat ne 0) then begin
		message, 'Error occurred when processing ' + cmd, /cont
		message, err, /cont
	endif
endif

;; Restore the backup Control file.
;; ------------------------------
;cmd = 'cp -p ' + storage.backup_cntl_file + $
;	' ' + storage.ccf_cntl_file
;spawn, cmd, res, err, exit = stat
;if (stat ne 0) then begin
;
;	message, 'Error occurred when processing ' + cmd, /cont
;	message, err, /cont
;	message, 'Skipped deleting the backup file.', /cont
;
;endif else begin
;
;	cmd = 'rm ' + storage.backup_cntl_file
;	spawn, cmd, res, err, exit = stat
;	if (stat ne 0) then begin
;		message, 'Error occurred when processing ' + cmd, /cont
;		message, err, /cont
;	endif
;
;endelse


ptr_free, storage.cntl
ptr_free, storage.change_flag

end


;--------------------------------------------------------------------
PRO ccf_control_panel_event, ev

;help, ev, /struct

widget_control, ev.top, get_uvalue = storage

WIDGET_CONTROL, ev.id, GET_UVALUE=uvalue

if (n_elements(uvalue) ge 2) then begin

; Event from droplist for sort key
; ------------------------------
	if (ev.id eq storage.w_sortkey) then begin

; 0 .. CCF NAME, 1 .. SET_NO, 2 .. REV_NO, ...
; -1 .. Original order
		sortkey = ev.index - 1

		widget_control, storage.rb_reverse, get_value = revflag

		index = widget_info(storage.w_cntlpos, /droplist_select)
		case index of
			0 : begin
				first_cntl = 1 & last_cntl = 0
			end
			1 : begin
				first_cntl = 0 & last_cntl = 1
			end
			2 : begin
				first_cntl = 0 & last_cntl = 0
			end
		endcase

		str = CCF_CNTL_Get_Table(*storage.cntl)
		str = CCF_CNTL_Sort_Table(str, sortkey, reverse_order = revflag, $
			first_cntl = first_cntl, last_cntl = last_cntl)

		widget_control, storage.w_tablelist, $
			set_value = str, set_uvalue = str

	endif

; Event from droplist for the position of CNTL
; ------------------------------
	if (ev.id eq storage.w_cntlpos) then begin
		
		case ev.index of
			0 : begin
				first_cntl = 1 & last_cntl = 0
			end
			1 : begin
				first_cntl = 0 & last_cntl = 1
			end
			2 : begin
				first_cntl = 0 & last_cntl = 0
			end
		endcase

		index = widget_info(storage.w_sortkey, /droplist_select)		
		sortkey = index - 1

		widget_control, storage.rb_reverse, get_value = revflag

		str = CCF_CNTL_Get_Table(*storage.cntl)
		str = CCF_CNTL_Sort_Table(str, sortkey, reverse_order = revflag, $
			first_cntl = first_cntl, last_cntl = last_cntl)

		widget_control, storage.w_tablelist, $
			set_value = str, set_uvalue = str

	endif

; Event from table list
; ------------------------------
	if (ev.id eq storage.w_tablelist) then begin

		widget_control, ev.id, get_uvalue = list
		selected = list[ev.index]

		tmp = CCF_CNTL_Split_Table(selected)
		index = where( $
			(*storage.cntl).name eq tmp[0] and $
			(*storage.cntl).set_no eq fix(tmp[1]) and $
			(*storage.cntl).rev_no eq fix(tmp[2]), $
			count)

		case count of
			0 : begin
				message, 'Cannot find CCF entry: ' + tmp[0] + $
					'of SET ' + tmp[1] + ' REV ' + tmp[2], /cont
				return
			end

			1 : begin
				; No problem. Go ahead.
			end

			else : begin
				message, 'Multiple CCF entries: ' + tmp[0] + $
					'of SET ' + tmp[1] + ' REV ' + tmp[2] + ' are found.', /cont
				return
			end

		endcase

		new_cntl = CCF_Cntl_Edit_Entry2(ev.top, index, storage)
;help, new_cntl, /struct
;help, (*storage.cntl)[index], /struct

		if ( n_tags(new_cntl) ne 0 ) then begin

			widget_control, /hourglass

			; Update CCF header
			ccf_filename = ccf_make_ccf_filename(new_cntl)
			ccf_data = ccf_read_ccf_file(ccf_filename, $
				header = header)

			if (new_cntl.test eq 0 and new_cntl.safe eq 1) then tmp = 'SAFE' $
			else tmp = 'TEST'
			header.status = tmp
			header.range = new_cntl.range
			command = 'date "+%Y-%m-%dT%H:%M:%S"'
			spawn, command, result
			header.cdate = result[0]
			header.comment = new_cntl.description

; Backup CCF before updating
; ------------------------------
backup_ccf_file = $
	'./' + strmid(ccf_filename, max(strsplit(ccf_filename, '/'))) + '.bak'
if ( file_test(backup_ccf_file) ) then begin
	i = 0
	repeat i++ until (not file_test(backup_ccf_file+'.'+strtrim(string(i),2)))
	backup_ccf_file = backup_ccf_file + '.' + strtrim(string(i),2)
endif


cmd = 'cp -p ' + ccf_filename + ' ' + backup_ccf_file
spawn, cmd, res, err, exit = stat
if (stat ne 0) then begin
	message, 'Error occurred when processing ' + cmd, /cont
	message, err, /cont
;	return
endif

			stat = ccf_write_ccf_file(ccf_make_ccf_filename(new_cntl), $
				ccf_data, header, /overwrite)

			; Update CNTL
			(*storage.cntl)[index] = new_cntl

			; Update CNTL display
			widget_control, storage.rb_reverse, get_value = revflag

			index = widget_info(storage.w_cntlpos, /droplist_select)
			case index of
				0 : begin
					first_cntl = 1 & last_cntl = 0
				end
				1 : begin
					first_cntl = 0 & last_cntl = 1
				end
				2 : begin
					first_cntl = 0 & last_cntl = 0
				end
			endcase

			index = widget_info(storage.w_sortkey, /droplist_select)		
			sortkey = index - 1

			str = CCF_CNTL_Get_Table(*storage.cntl)
			str = CCF_CNTL_Sort_Table(str, sortkey, reverse_order = revflag, $
				first_cntl = first_cntl, last_cntl = last_cntl)

			widget_control, storage.w_tablelist, $
				set_value = str, set_uvalue = str

		endif

	endif

endif else begin
; Event from the other widgets
; ------------------------------

	CASE uvalue OF

		'RB_REVERSE' : begin
			index = widget_info(storage.w_sortkey, /droplist_select)		
			sortkey = index - 1

			index = widget_info(storage.w_cntlpos, /droplist_select)
			case index of
				0 : begin
					first_cntl = 1 & last_cntl = 0
				end
				1 : begin
					first_cntl = 0 & last_cntl = 1
				end
				2 : begin
					first_cntl = 0 & last_cntl = 0
				end
			endcase

			widget_control, storage.rb_reverse, get_value = revflag

			str = CCF_CNTL_Get_Table(*storage.cntl)
			str = CCF_CNTL_Sort_Table(str, sortkey, reverse_order = revflag, $
				first_cntl = first_cntl, last_cntl = last_cntl)

			widget_control, storage.w_tablelist, $
				set_value = str, set_uvalue = str
		end

		'Quit'   : WIDGET_CONTROL, ev.top, /DESTROY

		'Save'	: begin

			if (not storage.updating_cntl) then return

			message, 'Updating ' + storage.ccf_cntl_file, /cont

			stat = ccf_write_ccf_file(storage.ccf_cntl_file, $
				*storage.cntl, storage.chdr, /overwrite)
			if (stat eq !FAIL) then return

			*storage.change_flag = 1B

		end

		'Add' : begin

			; Search CCFs in the CCF/data directory.
			; ------------------------------
			command = '/bin/ls ' + !CCF_PATH + '*.ccf'
			spawn, command, res, err, exit = stat
			if (stat ne 0) then begin
				message, 'Error occurred when processing ' + command, /cont
				message, err, /cont
				return
			endif
			ccf_list = res

			; Find CCFs which have not registered with CNTL yet.
			; ------------------------------
			for i = 0, n_elements(*storage.cntl)-1 do begin
				ccf_in_cntl = file_basename(ccf_make_ccf_filename((*storage.cntl)[i]))
				index = where(file_basename(ccf_list) eq ccf_in_cntl, count)
				if (count ne 0) then ccf_list[index] = ''
			endfor

			index = where(ccf_list ne '', count)
			if (count eq 0) then begin
				message, 'No CCFs to be added.', /continue
				return
			endif
			ccf_list = ccf_list[index]

			; Launch Header Entry Editor
			; ------------------------------
			new_header = CCF_Edit_Header_Entry(ev.top, ccf_list = ccf_list, $
				cntl_header = cntl_header)

			if (n_tags(new_header) eq 0) then begin
				message, 'Aborted adding CCF.', /cont
				return
			endif

			; Read New CCF to be added.
			; ------------------------------
			ccf_filename = ccf_make_ccf_filename(new_header)
			ccf_data = ccf_read_ccf_file(ccf_filename, $
				header = header)

			; Updating Header items.
			; ------------------------------
			header.status = new_header.status
			header.range = new_header.range
			command = 'date "+%Y-%m-%dT%H:%M:%S"'
			spawn, command, result
			header.cdate = result[0]
			header.fmtver = new_header.fmtver
			header.comment = new_header.comment

; Backup CCF before updating
; ------------------------------
backup_ccf_file = $
	'./' + strmid(ccf_filename, max(strsplit(ccf_filename, '/'))) + '.bak'
if ( file_test(backup_ccf_file) ) then begin
	i = 0
	repeat i++ until (not file_test(backup_ccf_file+'.'+strtrim(string(i),2)))
	backup_ccf_file = backup_ccf_file + '.' + strtrim(string(i),2)
endif


cmd = 'cp -p ' + ccf_filename + ' ' + backup_ccf_file
spawn, cmd, res, err, exit = stat
if (stat ne 0) then begin
	message, 'Error occurred when processing ' + cmd, /cont
	message, err, /cont
;	return
endif

			stat = ccf_write_ccf_file(ccf_filename, $
				ccf_data, header, /overwrite)


			message, 'Adding to CNTL..', /cont

			tmp = (*storage.cntl)[0]			; Template of CNTL structure
			tmp.name = cntl_header.name
			tmp.set_no = cntl_header.set_no
			tmp.rev_no = cntl_header.rev_no
			tmp.test = cntl_header.test
			tmp.safe = cntl_header.safe
			tmp.fisas = cntl_header.fisas
			tmp.fis01 = cntl_header.fis01
			tmp.fis02 = cntl_header.fis02
			tmp.fis03 = cntl_header.fis03
			tmp.range = cntl_header.range
			tmp.description = cntl_header.description

			*storage.cntl = [*storage.cntl, tmp]

			widget_control, storage.rb_reverse, get_value = revflag

			index = widget_info(storage.w_cntlpos, /droplist_select)
			case index of
				0 : begin
					first_cntl = 1 & last_cntl = 0
				end
				1 : begin
					first_cntl = 0 & last_cntl = 1
				end
				2 : begin
					first_cntl = 0 & last_cntl = 0
				end
			endcase

			index = widget_info(storage.w_sortkey, /droplist_select)		
			sortkey = index - 1

			str = CCF_CNTL_Get_Table(*storage.cntl)
			str = CCF_CNTL_Sort_Table(str, sortkey, reverse_order = revflag, $
				first_cntl = first_cntl, last_cntl = last_cntl)

			widget_control, storage.w_tablelist, $
				set_value = str, set_uvalue = str

		end

		'New'    :  begin

			; If NEW_CCF_DATA is a scalar and is equal to NaN,
			; launch DIALOG_PICKFILE
			if (n_tags(storage.new_ccf_data) eq 0) then begin
				if (n_elements(storage.new_ccf_data) eq 1) then begin
					if finite(storage.new_ccf_data, /nan) then begin

						savfile = dialog_pickfile(path = '.', $
							filter = ['*.sav', '*.dat', '*.txt', '*'])
						ccf_data = ccf_load_savefile(savfile, ERROR = error)
						if (error eq !FAIL) then return

					endif else ccf_data = storage.new_ccf_data
				endif else ccf_data = storage.new_ccf_data
			endif else ccf_data = storage.new_ccf_data


			header = CCF_Edit_Header_Entry(ev.top, ccf_data = ccf_data, $
				cntl_header = cntl_header)

			if (n_tags(header) eq 0) then begin
				message, 'Failed to create new CCF.', /cont
				return
			endif

			stat = ccf_write_ccf_file(ccf_make_ccf_filename(header), $
				ccf_data, $
				header)

			if (stat eq !FAIL) then begin
				message, 'Failed to create new CCF.', /cont
				return
			endif else begin

				message, 'Created new CCF:' + $
					ccf_make_ccf_filename(header), /cont

				message, 'Adding to CNTL..', /cont
				*storage.cntl = [*storage.cntl, cntl_header]

				widget_control, storage.rb_reverse, get_value = revflag

				index = widget_info(storage.w_cntlpos, /droplist_select)
				case index of
					0 : begin
						first_cntl = 1 & last_cntl = 0
					end
					1 : begin
						first_cntl = 0 & last_cntl = 1
					end
					2 : begin
						first_cntl = 0 & last_cntl = 0
					end
				endcase

				index = widget_info(storage.w_sortkey, /droplist_select)		
				sortkey = index - 1

				str = CCF_CNTL_Get_Table(*storage.cntl)
				str = CCF_CNTL_Sort_Table(str, sortkey, reverse_order = revflag, $
					first_cntl = first_cntl, last_cntl = last_cntl)

				widget_control, storage.w_tablelist, $
					set_value = str, set_uvalue = str

				return

			endelse
		end

		else : 

	ENDCASE

endelse

END



;--------------------------------------------------------------------
;PRO ccf_edit_cntl_file, ERROR=error
PRO ccf_control_panel, $
	updating_cntl = updating_cntl, $
	ccf_cntl_file = ccf_cntl_file, $
	new_ccf_data = new_ccf_data, $
	ERROR=error


XSIZE_DEF = 900
YSIZE_DEF = 200

; set charsize
;charsize, 1.5

if (not keyword_set(updating_cntl)) then $
	updating_cntl = 1B

; Control File Name
CCF_CNTL_FILE_NAME = 'CNTL__001_001.ccf'

if (NOT Keyword_Set(CCF_CNTL_FILE)) then $
	ccf_cntl_file = !CCF_PATH + CCF_CNTL_FILE_NAME


; Backup Control CCF file before editing
; ------------------------------
backup_cntl_file = './' + CCF_CNTL_FILE_NAME + '.bak'
if ( file_test(backup_cntl_file) ) then begin

	i = 0
	repeat i++ until (not file_test(backup_cntl_file+'.'+strtrim(string(i),2)))

	backup_cntl_file = backup_cntl_file + '.' + strtrim(string(i),2)
	
endif

;	repstr(strmid(string(systime(/seconds),format = '(f0)'), 6), '.', '')

cmd = 'cp -p ' + ccf_cntl_file + ' ' + backup_cntl_file
spawn, cmd, res, err, exit = stat
if (stat ne 0) then begin
	message, 'Error occurred when processing ' + cmd, /cont
	message, err, /cont
	return
endif


; read Control CCF file
cntl = CCF_Read_CCF_File(ccf_cntl_file, HEADER=chdr, ERROR=err)
if (err EQ !FAIL) then begin
	MESSAGE, 'Invalid CCF CNTL File.', /CONTINUE
	error = !FAIL
	return
endif

; create a base window
base = WIDGET_BASE(/COLUMN, title = 'CCF control panel : ' + ccf_cntl_file)
mbase = WIDGET_BASE(base, /ROW)
btn_exit = WIDGET_BUTTON(mbase, VALUE='   Quit   ', UVALUE='Quit')
btn_new  = WIDGET_BUTTON(mbase, VALUE=' Create New CCF', UVALUE='New')
btn_add  = WIDGET_BUTTON(mbase, VALUE=' Add CCF', UVALUE='Add')
save_cntl_button = WIDGET_BUTTON(mbase, VALUE='Save CNTL', UVALUE='Save')
if (not updating_cntl) then $
	widget_control, save_cntl_button, sensitive = 0


; Show CNTL table.
lbase = WIDGET_BASE(base, /COLUMN, FRAME=1)
header = CCF_CNTL_Show_Header2(lbase)

cntl_str = CCF_CNTL_get_table(cntl)
cntl_str = CCF_CNTL_sort_table(cntl_str)
w_tablelist = widget_list(lbase, xsize = 100, ysize = 20, $
	value = cntl_str, uvalue = cntl_str)


; Sorting Control
; ------------------------------
label = widget_label(mbase, value = 'Sort by :')
w_sortkey = widget_droplist(mbase, $
	value = ['Original', header], $
	uvalue = ['Original', header])
rb_reverse = cw_bgroup(mbase, 'Reverse Order', $
	/nonexclusive, column = 1, set_value = 0, $
	uvalue = 'RB_REVERSE')
label = widget_label(mbase, value = 'Show CNTL at :')
w_cntlpos = widget_droplist(mbase, $
	value = ['First', 'Last', 'No care'], $
	uvalue = ['First', 'Last', 'No care'])

; If NEW_CCF_DATA is not specified,
; substitute NaN for it and ignore further process.
; ------------------------------
if (not keyword_set(new_ccf_data)) then new_ccf_data = !values.d_nan


; Preparing data storage.
; ------------------------------
storage = { $
	cntl:ptr_new(cntl), $
	updating_cntl:updating_cntl, $
	ccf_cntl_file:ccf_cntl_file, $
	chdr:chdr, $
	backup_cntl_file:backup_cntl_file, $
	change_flag:ptr_new(0B), $
	new_ccf_data:new_ccf_data, $
	w_tablelist:w_tablelist, $
	w_sortkey:w_sortkey, $
	rb_reverse:rb_reverse, $
	w_cntlpos:w_cntlpos $
	}
widget_control, base, set_uvalue = storage, /no_copy

; show the window
WIDGET_CONTROL, base, /REALIZE

;if (n_tags(new_ccf_data) eq 0) then begin
;	if (n_elements(new_ccf_data) eq 1) then begin
;		if finite(new_ccf_data, /nan) then begin
;			widget_control, base, send_event = {WIDGET_BUTTON, $
;			ID:btn_new, top:base, handler:base, select:1}
;		endif
;	endif
;endif

; wait for events
XMANAGER, "ccf_control_panel", base, $
	cleanup = 'ccf_control_panel_cleanup'

END

