
; =======================================================================
FUNCTION CCF_Data_Definition_String, $
   ccf, $            ; Constant or array data
   FMT=fmt, $        ; Format for data body
   DIM=dim, $        ; Data dimension
   ERROR=error       ; Scolor or array data
                     ; (returned) Data format string

; reset error
   error = !SUCCEED

; Check data dimension
   ndim = SIZE(ccf, /N_DIMENSIONS)
   dim = SIZE(ccf, /DIMENSION)

; Check data type and set data format element
   type = SIZE(ccf, /TNAME)

   CASE type OF
      'BYTE': fmt = 'I'
       'INT': fmt = 'I'
      'UINT': fmt = 'I'
      'LONG': fmt = 'I'
     'ULONG': fmt = 'I'
     'FLOAT': fmt = 'E14.5'
    'DOUBLE': fmt = 'E20.10'
    'STRING': fmt = 'A'
		'LONG64': fmt = 'I'
		'ULONG64': fmt = 'I'
       else : begin
         MESSAGE, 'Invalid data type ('+type+').', /CONTINUE
         error = !FAIL
         return, error 
       end
   ENDCASE

   if (ndim EQ 0) then begin
      defs = STRING('C ', type, /PRINT)
   endif else begin
      defs = STRING('A ', type, dim, /PRINT)
   endelse

   return, defs
END ; CCF_Data_Definition_String


;--------------------------------------------------------------------
function CCF_Data_Defs, ccf, FMT = fmt_e, DIM = dim_e, ERROR = error

; 08/02/20 NI Newly created.

; reset error
error = !SUCCEED

str = ''

if (SIZE(ccf, /TNAME) EQ 'STRUCT') then begin

   nstruct = N_ELEMENTS(ccf)
   tagname_list = TAG_NAMES(ccf)
   ntag = n_elements(tagname_list)

   defs  = STRARR(ntag)
   fmt_e = STRARR(ntag)
   dim_e = lonarr(ntag)

   str = [str, string('S ', nstruct)]
   for i = 0L, ntag - 1 do begin
      if (nstruct GT 1) then tccf = ccf[0].(i) else tccf = ccf.(i)
      defs[i] = CCF_Data_Definition_String(tccf, FMT=fmt, DIM=dim, ERROR=error)
			fmt_e[i] = fmt
;			dim_e[i] = dim
      if (error EQ !FAIL) then begin
         MESSAGE, 'Unable to set CCF data definition.', /CONTINUE
         return, error
      endif

      str = [str, string('   T ', tagname_list[i], ' ', defs[i])]
   endfor

endif else begin

	defs = CCF_Data_Definition_String(ccf, FMT=fmt_e, DIM=dim_e, ERROR=error)
	if (error EQ !FAIL) then begin
		MESSAGE, 'Unable to set CCF data definition.', /CONTINUE
		return, error
	endif

	str = [str, defs]

endelse

str = str[1:*]

return, str

end ; CCF_Data_Defs
