;;fts_calspec,dc,0,0,0,[-0.2,0.2],2,vifstored=filename+'_part1.sav',addname='_2mm'

PRO fts_calspec, dc, oneside, smop, mcal, range, setcbp, phase, rampcorr, linearip, pixflg, apd = apd, vifstored = vifstored, addname = addname

COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext, quitflg
COMMON share_if,vif,vifpos,vif2,vifbad
COMMON share_mirubara,wn0,wcnt0,icnt,icntg,icntb,spec0,spec0g,spec0b,$
        oddinteg,oddintegg,oddintegb,cbpch,cbs,cbsg,cbsb
COMMON share_mirubara2,posmae,vifmae,posato,vifato,cballch
COMMON share_mirubara_long, longposmae,longifmae,longposato,longifato
COMMON share_dft,wn,wcnt,spec,longifspec,specbara
COMMON share_name,filename0,addname0, newname
COMMON share_s, wns, shortifspec, phasepara
COMMON share_r,  radec_a, radec_g, skipgui, lineline


bad=y_bad_val_def()

if (keyword_set(vifstored) eq 0) then begin

  if (n_elements(range) eq 0) then begin
  
    if (pktid_f eq 124) then range = [-0.42, 0.42] else $
      if (pktid_f eq 14) then range = [-2.70, 0.0] ;cm
  endif

  if (oneside eq 1) then range[1] = 0.0 ;cm

;; interpolate bad data

  fts_resetin, bad, mcal, linearip

;; smooth interferogram

;   if (smop gt 0) then begin
;      vifvif=dblarr(ndata,ndrv,ndet)
;      for sm=0, smop*2 do begin 
;         vifvif=vifvif+shift(vif,sm-smop)
;      endfor
;      vif=vifvif/(smop*2+1)
;   endif

   vifsto = 0  ;; keword_set(vifstored) = 0

;; make aveif
   if (pktid_f eq 124) then  pa =1  else if (pktid_f eq 14) then pa = 0
   aveif = dblarr(ndata,3, ndet) 
   for ch = 0, ndet-1 do begin
      for n = 0, ndata-1 do begin
         x = vif[n, pa:ndrv-1, ch]
         xf = vifbad[n, pa:ndrv-1, ch]
         wav = where(xf eq 0, nwav)
         if (nwav eq 0) then aveif[n, *, ch] = [bad, bad, 0] $
         else begin
            mom = moment(x[wav])
            aveif[n, *, ch] = [mom[0], sqrt(mom[1]), nwav]
         endelse
      endfor
   endfor
   avepos=vifpos[*,pa:ndrv-1]#(dblarr(ndrv-pa)+1.0)/(ndrv-pa)


endif else begin
   if (n_elements(range) gt 0) then newrange = range
   if (n_elements(apd) gt 0) then newapd = apd
   if (keyword_set(addname) eq 0) then addname=''

;; clear common variables and restore 
   fts_clear_common
   restore,vifstored
   sss=size(vif)
   ndata=sss[1]
   ndrv=sss[2]
   ndet=sss[3] 
   vifsto=1
   addname0=addname
   if (n_elements(newrange) gt 0) then range = newrange
   if(n_elements(newapd) gt 0) then apd = newapd
   if (n_elements(apd) eq 0) then apd = 'rect'
endelse

;; coefficient of Fourier transform
;; for SED : 2
;; for full-reso or oneside : 4
;if (pktid_f eq 124) then coef=2
;if (pktid_f eq 123) then coef=2
;if ((pktid_f eq 14) or (oneside eq 1)) then coef=4

if(range[0]*range[1] ge 0) then coef = 4 else coef = 2

;; determine the position of the center-burst

fts_makecbset,mcal,vifsto,setcbp, apd   ;; cbs, cbpch, longif, shortif are defined

;; make wavenumber array

fts_makewn,range,oneside            ;; wn is defined


;; DFT averaged interferogram (make aveifspec)
if (n_elements(avepos) gt 0) then begin 
   aveifspec = dblarr(wcnt,3, 2, ndet)
   for n = 0, ndet-1 do begin
      aveifspec[*,0:1,0,n]=justdft((avepos[0:ndata/2-1]-cballch[n,0]), $
                                 aveif[0:ndata/2-1,0, n],range,0,wn, apd)*coef
      aveifspec[*,0:1,1,n]=justdft((avepos[ndata/2:ndata-1]-cballch[n,1]),$
                                 aveif[ndata/2:ndata-1,0, n],range,0,wn, apd)*coef
      print, 'DFT(averaged interferogram (1/2)) ...', string(n+1, format = '(i2)'), '/', string(ndet, format = '(i2)')
   endfor
   aveifspec[*,2,*,*]=atan(aveifspec[*,1,*,*], aveifspec[*,0, *,*])*180/!pi
endif

;; DFT long interferogram (make longifspec)

longifspec=dblarr(wcnt,2,2,ndet);;[wn,e/o,g/b,ndet]

for n=0,ndet-1 do begin
  longifspec[*,*,0,n]=justdft((longposmae[*]-cballch[n,0]),longifmae[*,n],range,0,wn, apd)*coef
  longifspec[*,*,1,n]=justdft((longposato[*]-cballch[n,1]),longifato[*,n],range,0,wn, apd)*coef
  print,'DFT(averaged interferogram (2/2)) ...',string(n+1, format = '(i2)'),'/',string(ndet, format = '(i2)')
endfor


;; DFT each interferogram (make specbara)

fts_dftdftdft,range,coef, apd

;; average each spectra (make spec)

fts_calavgspec, totspec

;plotbara,30,0

if(n_elements(newname) eq 0) then begin
  gzpos = strpos(filename0, '.gz')
  if(gzpos ne -1) then $
    newname = strmid(filename0, 0, strlen(filename0)-8L)+addname0 $
  else newname = strmid(filename0, 0, strlen(filename0)-5L)+addname0
endif

;; for full-reso data, mae = back, ato = go
;; spec[nwn, 2, 3, 2(mae/ato), ndet] -> spec[nwn, 2, 3, 2(go/back), ndet]

if(pktid_f eq 14) then begin
  spec = reverse(spec, 4, /overwrite)
  specbara = reverse(specbara, 4, /overwrite)
  shortifspec = reverse(shortifspec, 3, /overwrite)
  longifspec = reverse(longifspec, 3, /overwrite)
  totspec = reverse(totspec, 2, /overwrite)
  aveifspec = reverse(aveifspec, 3, /overwrite)
endif

save, vifpos,vif,vifbad,wn,spec,dc,cbpch, cballch,datatype,pktid_f,rstext,$
      filename0,smop,longifmae,longifato,longposmae,longposato,longifspec,$
      specbara,ver,pch,range,rampcorr,totspec,wns, shortifspec, $
      radec_a, radec_g,aveif, avepos,aveifspec,phasepara,apd, pixflg, filename=newname+'_part1.sav'

if(n_elements(skipgui) eq 0 ) then fts_checkrawspec

MESSAGE,'FINISH.',/continue
end
