pro fts_check_input, filename, stati, tiskip, oneside, plotch, mcal, rampcorr, rampbflg, addname, vifbadf, pixflg, extra_x, range, sigmaclip, setcbp, linearip, apd

  tmp = file_test(filename)
  if(tmp ne 1L) then message, filename+' does not exist'

  if(keyword_set(stati)) then begin
    tmp = size(stati, /tname)
    if(((tmp ne 'INT') and (tmp ne 'LONG')) or (size(stati, /n_dimensions) ne 0)) then message, 'STATI should be scalar integer'
  endif

  if(keyword_set(tiskip)) then begin
    tmp = size(tiskip, /tname)
    if((tmp ne 'INT') and (tmp ne 'LONG')) then message, 'TISKIP should be {0,1,2}'
    if((tiskip ne 0L) and (tiskip ne 1L) and (tiskip ne 2L)) then message, 'TISKIP should be {0,1,2}'
  endif

  if(keyword_set(oneside)) then begin
    if((oneside ne 0L) and (oneside ne 1L)) then message, 'ONESIDE should be {0,1}'
  endif

  if(keyword_set(plotch)) then begin
    tmp = size(plotch, /tname)
    if(((tmp ne 'INT') and (tmp ne 'LONG')) or (size(plotch, /n_dimensions) ne 0)) then message, 'PLOTCH should be scalar integer'
  endif

  if(keyword_set(mcal)) then begin
    if((mcal ne 0L) and (mcal ne 1L)) then message, 'MCAL should be {0,1}'
  endif

  if(keyword_set(rampcorr)) then begin
    tmp = size(rampcorr, /tname)
    if((tmp eq 'INT') or (tmp eq 'LONG')) then begin
      if((rampcorr ne 3L) and (rampcorr ne 1L) and (rampcorr ne 2L)) then message, 'RAMPCORR should be {1,2,3} or string'
    endif else begin
      if(tmp eq 'STRING') then begin
        tmp2 = file_test(rampcorr)
        if(tmp2 ne 1L) then message, rampcorr+' does not exist'
      endif else begin
        message, 'RAMPCORR should be {1,2,3} or string'
      endelse
    endelse
  endif

  if(keyword_set(rampbflg)) then begin
    if(keyword_set(rampcorr) ne 1L) then message, 'use RAMPBFLG with RAMPCORR=1'
    if(rampcorr ne 1L) then message, 'use RAMPBFLG with RAMPCORR=1'
    tmp = size(rampbflg, /tname)
    if(tmp ne 'STRING') then message, 'RAMPBFLG should be string'
    tmp2 = file_test(rampbflg)
    if(tmp2 ne 1L) then message, rampbflg+' does not exist'
  endif

  if(keyword_set(addname)) then begin
    tmp = size(addname, /tname)
    if(tmp ne 'STRING') then message, 'ADDNAME should be string'
  endif

  if(keyword_set(vifbadf)) then begin
    tmp = size(vifbadf, /tname)
    if(tmp ne 'STRING') then message, 'VIFBADF should be string'
    tmp2 = file_test(vifbadf)
    if(tmp2 ne 1L) then message, VIFBADF+' does not exist'
  endif

  if(keyword_set(pixflg)) then begin
    tmp = size(pixflg, /tname)
    if((tmp ne 'INT') and (tmp ne 'LONG')) then message, 'PIXFLG should be integer'
  endif

  if(keyword_set(extra_x)) then begin
    tmp = size(extra_x, /tname)
    if((tmp ne 'INT') and (tmp ne 'LONG') and (tmp ne 'FLOAT') and (tmp ne 'DOUBLE')) then message, 'EXTRA_X should be value'
  endif

  if(keyword_set(range)) then begin
    tmp = size(range, /tname)
    if((tmp ne 'INT') and (tmp ne 'LONG') and (tmp ne 'FLOAT') and (tmp ne 'DOUBLE')) then message, 'RANGE should be value'
    tmp = n_elements(range)
    if(tmp ne 2) then message, 'RANGE should be array with 2 elements'
  endif

  if(keyword_set(sigmaclip)) then begin
    if((sigmaclip ne 0L) and (sigmaclip ne 1L)) then message, 'SIGMACLIP should be {0,1}'
  endif

  if(keyword_set(setcbp)) then begin
    if((setcbp ne 0L) and (setcbp ne 1L)) then message, 'SETCBP should be {0,1}'
  endif

  if(keyword_set(linearip)) then begin
    if((linearip ne 0L) and (linearip ne 1L)) then message, 'LINEARIP should be {0,1}'
  endif

  if(keyword_set(skipguis)) then begin
    if((skipguis ne 0L) and (skipguis ne 1L)) then message, 'SKIPGUIS should be {0,1}'
  endif

  if(keyword_set(linespec)) then begin
    if((linespec ne 0L) and (linespec ne 1L)) then message, 'LINESPEC should be {0,1}'
  endif

  if(keyword_set(phase)) then begin
    if((phase ne 0L) and (phase ne 1L)) then message, 'PHASE should be {0,1}'
  endif

  if(keyword_set(apd)) then begin
    if((apd ne 'rect') and (apd ne 'tri') and (apd ne 'hanning') and (apd ne 'connes')) then message, 'APD should be {"rect" or "tri" or "hanning" or "connes"}'

    if(keyword_set(range)) then $
      if((apd ne 'rect') and (range[0] ne range[1]*(-1)) and (range[1] ne 0)) then message, 'range should be [-a,a] or [-a,0] in apodization other than "rect"'

  endif

end
