pro fts_check_ramprange, a, datatype, pixflg

  size_a = size(a, /dimensions)
  nch = size_a[2]
  nch_w = size_a[2]*3L/5L

  cvsroot = GETENV('FISDR_ROOT')

  if(datatype eq 'FIS_SW') then begin
    commonrangefile = cvsroot+'/fts/fts_part1/data/corr_tbl_yrng_SW.sav'
    if (n_elements(pixflg) eq 0) then badpix = [0, 10] else badpix = [pixflg-1, 0, 10]
  endif else begin
    commonrangefile = cvsroot+'/fts/fts_part1/data/corr_tbl_yrng_LW.sav'
    if (n_elements(pixflg) eq 0) then badpix = [1, 2, 17, 32, 41] else badpix = [pixflg-1, 1, 2, 17, 32, 41]
  endelse

  restore, commonrangefile

  nnocorrect = 0L

  warning = 'Cannot corrected for channel '

  for ich = 0L, nch_w-1L do begin

    if(where(badpix eq ich) ne -1) then continue

    thisrange = yrange[*, ich]
    thisa = a[*, 0, ich]

    tmp = where((thisa ge thisrange[0]) and (thisa le thisrange[1]), nuse)

    if(nuse le 1) then begin
      if(nnocorrect eq 0L) then warning = warning+strtrim(string(ich+1L), 2) $
        else warning = warning+','+strtrim(string(ich+1L), 2)

      nnocorrect = nnocorrect+1L
    endif

  endfor

  if(nnocorrect eq 0L) then return

  warning = warning+' because it is too bright.'

  tmp = dialog_message(warning)

end
