;; y_eval_ramp_corr η̤åġ

pro fts_check_y_eval_ramp_corr_event, event

  COMMON share_im, x, xx, v, a, extra_x
  COMMON share_plotparam, ich, xrange, yrange, xrange_ori, yrange_ori, xscale, aveplot, nsmpl, bad
  COMMON groupleader, base0
  COMMON range_text, rbasexminout, rbasexmaxout, rbaseyminout, rbaseymaxout

  widget_control, event.id, get_uvalue = uval

  case uval of
    'quit' : widget_control, event.top, /destroy
    'range': begin
      rbase = widget_base(row = 3, xsize = 350, ysize = 100, title = 'range')
      rbasex = widget_base(rbase, column = 4)
      rbasey = widget_base(rbase, column = 4)
      rbasexmin = widget_label(rbasex, value = 'xmin', /align_center)
      rbasexminout = widget_text(rbasex, value = string(xrange[0]), /editable, xsize = 20, ysize = 1, uvalue = 'rangeok')
      rbasexmax = widget_label(rbasex, value = 'xmax', /align_center)
      rbasexmaxout = widget_text(rbasex, value = string(xrange[1]), /editable, xsize = 20, ysize = 1, uvalue = 'rangeok')
      rbaseymin = widget_label(rbasey, value = 'ymin', /align_center)
      rbaseyminout = widget_text(rbasey, value = string(yrange[0]), /editable, xsize = 20, ysize = 1, uvalue = 'rangeok')
      rbaseymax = widget_label(rbasey, value = 'ymax', /align_center)
      rbaseymaxout = widget_text(rbasey, value = string(yrange[1]), /editable, xsize = 20, ysize = 1, uvalue = 'rangeok')

      rbaseokcancel = widget_base(rbase, column = 2)
      rbaseok = widget_button(rbaseokcancel, value = 'OK', uvalue = 'rangeok')
      rbasecancel = widget_button(rbaseokcancel, value = 'Cancel', uvalue = 'rangecancel')

      widget_control, base0, sensitive = 0
      widget_control, rbase, /realize
      xmanager, 'fts_check_y_eval_ramp_corr', rbase, /no_block
    end
    'rangeok' : begin
      widget_control, rbasexminout, get_value = xminout
      widget_control, rbasexmaxout, get_value = xmaxout
      widget_control, rbaseyminout, get_value = yminout
      widget_control, rbaseymaxout, get_value = ymaxout
      xrange = [xminout, xmaxout]
      yrange = [yminout, ymaxout]
      widget_control, event.top, /destroy
      widget_control, base0, /sensitive
      plotplot
    end
    'rangecancel' : begin
      widget_control, event.top, /destroy
      widget_control, base0, /sensitive
      plotplot
    end
    'replot' : begin
      xrange = xrange_ori
      yrange = yrange_ori
      widget_control, base0
      plotplot
    end
    'xscale_on' : begin
      xscale = 1L
      widget_control, base0
      plotplot
    end
    'xscale_off' : begin
      xscale = 0L
      widget_control, base0
      plotplot
    end
    'ave_plot_on' : begin
      aveplot = 1L
      widget_control, base0
      plotplot
    end
    'ave_plot_off' : begin
      aveplot = 0L
      widget_control, base0
      plotplot
    end
    else   : begin
      widget_control, event.id, get_value = pch
      ich = pch-1L
      aich = a[*, *, ich]
      nobaddata = where(aich ne bad, cnt)
      if(cnt ne 0) then yrange_ori = [min(aich[nobaddata]), max(aich[nobaddata])] $
        else yrange_ori = [bad, bad]
      yrange = yrange_ori
      plotplot
    endelse
  endcase

end

pro plotplot

  COMMON share_im, x, xx, v, a, extra_x
  COMMON share_plotparam, ich, xrange, yrange, xrange_ori, yrange_ori, xscale, aveplot, nsmpl, bad
  COMMON groupleader, base0

  ;loadmycolors_all, names = colorname
  device, true_color = 24
  ;device, decomposed = 0

  BAD = y_bad_val_def()

  titleword = 'ch '+strtrim(string(ich+1), 2)

  if(xscale eq 1L) then thisxx = xx[*, *, ich] else thisxx = x[*, *, ich]
  thisyy = v[*, *, ich]

  idx = where((thisxx ne bad) and (thisyy ne bad), usedata)

  if(usedata ne 0) then begin
    thisxx = thisxx[idx]
    thisyy = thisyy[idx]

    thisxxmin = min(thisxx, max = thisxxmax)
    plotx = (thisxx - thisxxmin) / (thisxxmax - thisxxmin) * DOUBLE(nsmpl-1 - extra_x[0]-extra_x[1]) + extra_x[0]

    y_plot_ramp, plotx, thisyy, xrange = xrange, yrange = yrange, xtitle = 'sample number', ytitle = 'detector output [V]'

    if(aveplot eq 1L) then oplot, a[*, *, ich], color = 'FF0000'XL, thick = 3
  endif else begin
    plot, xrange, yrange, /nodata
  endelse

end

pro fts_check_y_eval_ramp_corr, savefile, extra_x = input_extra_x

  COMMON share_im, x, xx, v, a, extra_x
  COMMON share_plotparam, ich, xrange, yrange, xrange_ori, yrange_ori, xscale, aveplot, nsmpl, bad
  COMMON groupleader, base0

  bad = y_bad_val_def()

  restore, savefile

  case (n_elements(input_extra_x)) of
    0:extra_x = [0, 0]
    1:extra_x = replicate(input_extra_x, 2)
    2:extra_x = input_extra_x
    else:message, 'bad format of extra_x'
  endcase

  nsmpl = (size(a, /dimensions))[0]
  nch = (size(a, /dimensions))[2]/5L*3L
  xx = x*fx+dx

;; initial value

  ich = 6L
  xscale = 1L
  aveplot = 1L
  pch = ich+1L

  xrange_ori = [0-extra_x[0]-1, nsmpl+extra_x[1]]
  aich = a[*, *, ich]
  nobaddata = where(aich ne bad, cnt)
  if(cnt ne 0) then yrange_ori = [min(aich[nobaddata]), max(aich[nobaddata])] $
  else yrange_ori = [bad, bad]

  xrange = xrange_ori
  yrange = yrange_ori

;; GUI process

  base0 = widget_base(title = 'fts_check_y_eval_ramp_corr: '+savefile, /column)
  draw0 = widget_draw(base0, xsize = 600, ysize = 400)

  base1 = widget_base(base0, column = 6)
  buttrange = widget_button(base1, value = 'range', uvalue = 'range')
  buttreplot = widget_button(base1, value = 'replot', uvalue = 'replot')

  basexscale = widget_base(base1, row = 2, /exclusive)
  buttxscaleon = widget_button(basexscale, value = 'xscale_on', uvalue = 'xscale_on')
  buttxscaleoff = widget_button(basexscale, value = 'xscale_off', uvalue = 'xscale_off')

  baseaveplot = widget_base(base1, row = 2, /exclusive)
  buttaveploton = widget_button(baseaveplot, value = 'ave_plot_on', uvalue = 'ave_plot_on')
  buttaveplotoff = widget_button(baseaveplot, value = 'ave_plot_off', uvalue = 'ave_plot_off')

  slidech = widget_slider(base1, value = pch, uvalue = 'pch', xsize = 150, min = 1, max = nch, title = 'channel')
  buttquit = widget_button(base1, value = 'ok', uvalue = 'quit')

  widget_control, buttxscaleon, /set_button
  widget_control, buttaveploton, /set_button
  widget_control, base0, /realize

  xmanager, 'fts_check_y_eval_ramp_corr', base0 ;, /no_block

end
