PRO fts_part1, $
  filename,	$;
  stati=stati, 	$;
;  fpi2=fpi2,$
  tiskip=tiskip,$; 1:for'--no-blank-insertion' data,
  oneside=oneside,$; 1:range[1]=0.0 (default:range=[-0.42,0.42]@SED, [-2.70,0]@full)
  plotch=plotch,$;;  1=ch1,2=ch2,,,
  mcal=mcal,$
  rampcorr=rampcorr,$;;; 1:ftsgb, 2:gb, '***ramptbl.ccf'
  rampbflg=rampbflg,$;;;ex  rampbflg='M82_p4_SW_mcal.fitsramp.sav'
  addname=addname,$
  vifbadf=vifbadf,$
;  smop = smop, $ ;;boxcar width = smop*2+1 data points
  pixflg = pixflg,  $;; ex pixflg = [6,7,31]
  EXTRA_X=extra_x, $
  range = range, $
  sigmaclip = sigmaclip, $
  setcbp = setcbp, $
  linearip = linearip, $
  skipguis = skipguis, $
  linespec = linespec, $
  phase = phase,  $
  apd = apd

device, retain = 2

COMMON share_n, ndata,ndrv,ndet,datatype,pktid_f,pch,ver,rstext,quitflg
COMMON share_if,vif,vifpos,vif2,vifbad
COMMON share_h, heads,tmprlcb,cb
COMMON share_name,filename0,addname0, newname
COMMON share1,x,ramp100,rampall, bad,rampflag,sname, xr, a, v, rctbl, sft
COMMON share_r,  radec_a, radec_g, skipgui, lineline

;;;;;;;;;;;;;;;;;;;;;;;;;
;; clear all variables ;;
;;;;;;;;;;;;;;;;;;;;;;;;;

fts_clear_common

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Usage and parameter check ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

if(keyword_set(filename) ne 1) then begin

  print, '------------------------USAGE-----------------------------'
  print, 'fts_part1, filename [,PLOTCH = integer] [,RAMPCORR = {1,2,3 or string}] [,RAMPBFLG = string] [,ADDNAME = string] [,VIFBADF = string] [,/MCAL] [,PIXFLG = integer vector] [,/SIGMACLIP] [,/SETCBP] [,APD = string]'
  print, '----------------------------------------------------------'
  return

endif

fts_check_input, filename, stati, tiskip, oneside, plotch, mcal, rampcorr, rampbflg, addname, vifbadf, pixflg, extra_x, range, sigmaclip, setcbp, linearip, apd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; constant and parameters ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; read version

  cvsroot = GETENV('FISDR_ROOT')
  versionfile = cvsroot+'/fts/fts_part1/pro/VERSION'
  openr, 1, versionfile
  ver = ''
  readf, 1, ver
  close, 1

;; read tsd
tsd=OBJ_NEW('tsd')
ret=tsd->Read_TSD(filename)
datatype=tsd->Get_Datatype()
pktid=tsd->Get_value_TSD('FIS_OBS','packetid')

;; set parameters
if ((keyword_set(setcbp) eq 1) and (Keyword_set(mcal) ne 1)) then tiskip = 2
if (keyword_set(oneside) eq 0) then oneside=0
if((keyword_set(plotch) eq 0) and (datatype eq 'FIS_SW'))then plotch=23
if((keyword_set(plotch) eq 0) and (datatype eq 'FIS_LW'))then plotch=7
pch=plotch-1
if (keyword_set(addname) eq 0) then addname=''
if (keyword_set(smop) eq 0) then smop=0
if (keyword_set(skipguis) eq 1) then skipgui=1
if (keyword_set(linespec) eq 1) then lineline=1

if (keyword_set(extra_x) eq 1) then extra_x = extra_x else extra_x = 0.5  ;; for rampcurve correction

if(keyword_set(apd) eq 0) then apd = 'rect'


;; srate : sampling rate 
;; ncantuse : number of samplings near center burst which cannot use for self-rampcurve correction (rampcorr=1)
if (datatype eq 'FIS_LW') then begin
  srate = 85.336
  ncantuse = 512
endif
if (datatype eq 'FIS_SW') then begin
  srate = 170.672
  ncantuse = 1024
endif

;if ((keyword_set(fpi2) eq 1) and (datatype eq 'FIS_LW')) then 	ncantuse = 250
;if((keyword_set(fpi2) eq 1) and (datatype eq 'FIS_SW')) then 	ncantuse = 500

bad = y_bad_val_def()  ;; -999
rstext = [0, 1]        ;; range of reset bad
filename0 = filename   ;; input filename
addname0 = addname     ;; optional prefix
coefpos = 2.0/10000    ;; position counter 1 count = coefpos [cm]

;; bad pixel and narrow detector
if (datatype eq 'FIS_SW') then badpi=[0,10,indgen(40)+60] $
 else badpi=[1,2,17,32,41,indgen(30)+45]

;; filename = 'xxx.fits' or 'xxx.fits.gz' -> newname = 'xxx'
gzpos = strpos(filename0, '.gz')
if(gzpos ne -1) then $
newname = strmid(filename0, 0, strlen(filename0)-8L)+addname0 $
else newname = strmid(filename0, 0, strlen(filename0)-5L)+addname0

;;;;;;;;;;;;;
;; process ;;
;;;;;;;;;;;;;

;; convert to volt unit, get parameters

clear_all_flag, tsd
ret=gb_flag_bad_data(tsd)
ret=gb_set_flag_rstanom(tsd)
ret=gb_conv_to_volt(tsd,FERR=0)

flux=tsd->Get_value_TSD('FIS_OBS','flux')	;;;[V]
rstflg=tsd->Get_Pix_Flag_TSD('FIS_OBS','RESET')
badflg=tsd->Get_Pix_Flag_TSD('FIS_OBS','bad')

;; data size

si = SIZE(flux)
ndet=si[1]*3/5
nn=si[2]

;; pick up WIDE data

;flux=flux[0:ndet-1,*]

flux[badpi, *] = bad
if (n_elements(pixflg) ge 1) then flux[pixflg-1, *] = bad

;; get RA DEC data

fts_radec2, filename, radec,/AOCU_ADS, tsd = tsd     ;; radec is defined
radec_a = radec
fts_radec2, filename, radec, tsd = tsd
radec_g = radec

;; for pre-launch data

;if (keyword_set(fpi2) eq 1) then begin
;  srate=srate*97.53/170.67
;  if (datatype eq 'FIS_SW')then begin
;    rstcnt=tsd->Get_value_TSD('FIS_OBS','rstcntwides')
;  endif else if (datatype eq 'FIS_LW')then begin
;    rstcnt=tsd->Get_value_TSD('FIS_OBS','rstcntwidel')
;  endif
;  wrst= where ((shift(rstcnt,1)-rstcnt) ne 0)
;  for n=0, ndet-1 do begin
;    rstflg[n,wrst]=1
;  endfor
;endif

;; position sensor

mpos=tsd->Get_value_TSD('FIS_OBS','MPOSCNT')
mpostobi=where((mpos-shift(mpos,1) gt 40000),nmt)
if (nmt gt 1) then begin
	tobips = where(mpos lt 20000)
	mpos[tobips]=mpos[tobips]+65536
	;mpos=mpos*(-1)
endif

mpos=double(mpos)
shiftmpos=shift(mpos,1)
mpos[1:nn-2]=(mpos[1:nn-2]+shiftmpos[1:nn-2])/2

;; rough center position of each interferogram

;if (keyword_set(fpi2) eq 1) then $
; fts_drvheads,tsd, pktid,mcal,ncantuse,tiskip,stati,fpi2=fpi2 $
;else $
  fts_drvheads, tsd, pktid, mcal, ncantuse, tiskip, stati  ;; heads, tmprlcb, cd are defined


seki=flux[0:ndet-1, *]  ;; seki = flux before ramp curve correction for plot

;; dif = differentiation before ramp curve correction for plot
dif=flux[0:ndet-1,*]
for ch=0, ndet-1 do begin
  dif[ch,*]=flux[ch,*]-shift(flux[ch,*],1)
endfor

dif=dif*srate   ;; [V/s]

;; ramp curve correction

quitflg = 0            ;; initial value 

if (size(rampcorr, /tname) eq 'INT') then begin
   if (rampcorr eq 2) then begin        ;; ramp curve correction table from suvey 
      ret=gb_Ramp_Curve_Corr(tsd)
      if (datatype eq 'FIS_SW') then ccf_file = 'RCTBS' $
      else if (datatype eq 'FIS_LW') then ccf_file ='RCTBL'
      rctbl = CCF_Read_CCF(ccf_file, tsd, ERROR=err, HEADER=hdr)
   endif else $
   if (rampcorr eq 1) then begin        ;; ramp curve correction by itself
      if (keyword_set(rampbflg) eq 1) then $
        fts_makerctbl, tsd, ncantuse, 1, savname3, pixflg, extra_x, $
        rampbflg = rampbflg $
      else  fts_makerctbl, tsd, ncantuse, 1,savname3, pixflg, extra_x   ;; make ccf file
      ret=GB_Ramp_Curve_Corr(tsd,ccf_file_rctb=savname3)
   endif
endif else $
if (size(rampcorr, /tname) eq 'STRING') then begin       ;; using given correction table
   ret=GB_Ramp_Curve_Corr(tsd,ccf_file_rctb=rampcorr)
   rctbl = CCF_Read_CCF_FILE(rampcorr, ERROR=err, HEADER=hdr)
 endif else $
if (size(rampcorr, /tname) eq 'UNDEFINED') then begin    ;; using default correction table for FTS
   if (datatype eq 'FIS_SW') then $
    crctbl = cvsroot+'/fts/fts_part1/data/check_all_rampsav_wnoscale_071012_SW.ccf' $
   else if (datatype eq 'FIS_LW') then $
    crctbl = cvsroot+'/fts/fts_part1/data/check_all_rampsav_wnoscale_071012_LW.ccf' 
    ret=GB_Ramp_Curve_Corr(tsd,ccf_file_rctb=crctbl)
    rctbl = CCF_Read_CCF_FILE(crctbl, ERROR=err, HEADER=hdr)

endif

ret=gb_differentiation(tsd)
;ret=gb_Set_Glitch_status_GP(tsd)
flux=tsd->Get_value_TSD('FIS_OBS','flux')	;;;[V]
flux=flux*srate     ;; [V/s]

flux[badpi, *] = bad
if (n_elements(pixflg) ge 1) then flux[pixflg-1, *] = bad

flux=flux[0:ndet-1,*]  ;; only WIDE
rstflg=rstflg[0:ndet-1,*]

;gpgl1flg=tsd->Get_Pix_Flag_TSD('FIS_OBS','GPGL_type1')
if ( keyword_set (skipguis) ne 1 ) then begin
   quitflg = 0
   fts_check_rampcorr,dif,flux,seki,-2
   if (quitflg eq 1) then stop
 endif

;; separate into each interferogram

fts_makevif,flux,mpos,rstflg,vifrst     ;; vif, vifpos, vifrst, vifbad are defined

;; [um] --> [cm]

vifpos=vifpos*coefpos

;; set bad for first packet
if (keyword_set(setcbp) eq 1)then begin
   vifpos[0:5, 0] = vifpos[6, 0]
   vif[0:5, 0, *] = bad
   vifbad[0:5, 0, *] = 1
endif

;if (keyword_set(fpi2) eq 1) then rstext=[0,0]

;; read bad file
if (n_elements(vifbadf) gt 0) then begin
   restore,vifbadf
   vif[where(vifbad eq 1)]=bad
   vif2=vif
endif $

;; set bad around reset
else   fts_rstflag,bad,vifrst,skipguis

x=y_xidx(vif)

;;rm_glitch

if (keyword_set(sigmaclip) eq 1) then fts_meanclip, mcal, ncantuse, bad

if ( keyword_set (skipguis) ne 1 ) then fts_rm_glitch
if (quitflg eq 1) then stop

;;boxcar
;   if (smop gt 0) then begin
;      vifvif=dblarr(ndata,ndrv,ndet)
;      for sm=0, smop*2 do begin
;         vifvif=vifvif+shift(vif,sm-smop)
;       endfor
;      vif=vifvif/(smop*2+1)
;    endif


;; subtract DC

dc=fts_avedc(ncantuse,bad,vif)
vifdc=rebin(reform(dc,1,ndrv,ndet),ndata,ndrv,ndet,/sample)
vif = vif-vifdc
vif[where(vifbad eq 1)] = bad

;dc=fts_avedc(ncantuse,bad,vif)
;bb=replicate(1D,ndata)
;dc=reform(dc,ndrv*ndet)
;vifdc=bb#dc
;vifdc=reform(vifdc,ndata,ndrv,ndet)
;dc=fts_avedc(ncantuse,bad,vif)
;aa=replicate(1D,ndrv)
;dcave=aa#dc/ndrv

;for ch=0, ndet-1 do begin
;   for i=0, ndrv-1 do begin
;      notbad=where((vifbad[*,i,ch] NE 1),nnb)
;      if ((nnb ne 0) and (dc[i,ch] ne 0)) then begin
;         vif[notbad,i,ch]=(vif[notbad,i,ch])*dcave[0,ch]/dc[i,ch]-dcave[0,ch]
;      endif
;   endfor
; endfor

OBJ_DESTROY, tsd

fts_calspec, dc, oneside, smop, mcal, range, setcbp, phase, rampcorr, linearip, pixflg, apd = apd


MESSAGE,'FINISH.',/continue
end
