pro fts_mk_obj_mcal_acal, allname, noobj = noobj, nomcal = nomcal, noacal = noacal, nodark = nodark

;; make *_obj.fits.gz, *_mcal.fits.gz file,  *_acal_b.fits.gz,
;;      *_acal_a.fits.gz, *_dark_1.fits.gz, *_dark_2.fits.gz, *_dark_3.fits.gz
;; from *_all.fits.gz file or *.fits.gz or *.fits

;;
;; ڤФδ
;; 
;; mcal
;; 
;; Ϥ MPosOn顣
;; TpCalFT > thres (=2e4)
;; ѤˤҤäʤ褦˺٤ϤĤݤƤ롣
;; դǾˤƤϤޤʤĤäȤƤ⡢ȴʤ
;; signal ꤭ʤȤ顢äƤޤǴޤࡣ
;; 
;; obj
;; 
;; Shtop = 1
;; blank LDSΥǥեȡˤϡtiskip ʤǡ
;; blank ᤺˽̤Ƥޤä tiskip=1  fts2 ˤ롣
;;
;; acal_b () acal_a ()
;;
;; CalALOn =1 5ðʾ³ƤΤǡ _b _a
;;  300 sample ;ʬˤĤƤ
;;
;; dark_1 () dark_2 () dark_3 ()
;;
;; ϰϤ20ô֡
;; dark_1 ϡmcal λϤޤ1ޤǡ
;; dark_2 ϡobj λϤޤ1ޤǡ
;; dark_3 ϡobj äƤ3ø夫顣
;;
;;
;; MODIFICATION HISTORY:
;;   Written by Y. Okada, 2006/11/17
;;

  if(n_params() ne 1) then begin
    print, '------------------------USAGE-----------------------------'
    print, 'fts_mk_obj_mcal_acal, filename [,/NOOBJ] [,/NOMCAL] [,/NOACAL] [,/NODARK]'
    print, '----------------------------------------------------------'
    return
  endif

;; sampling rate (SW, LW)

  srate = [170.66D, 85.33D]

;; read _all file

  mytsd = OBJ_NEW('tsd')
  ret = mytsd->Read_TSD(allname)

;; prepare output

  objfilename = ''
  mcalfilename = ''
  acalbfilename = ''
  acalafilename = ''
  dark1filename = ''
  dark2filename = ''
  dark3filename = ''

  gzpos = strpos(allname, '.gz')
  if(gzpos ne -1) then begin
    newlength = strlen(allname)-3L
    allname = strmid(allname, 0, newlength)
  endif

  allpos = strpos(allname, '_all')
  if(allpos ne -1) then begin
    objfilename = strmid(allname, 0, allpos)+'_obj.fits'
    mcalfilename = strmid(allname, 0, allpos)+'_mcal.fits'
    acalbfilename = strmid(allname, 0, allpos)+'_acal_b.fits'
    acalafilename = strmid(allname, 0, allpos)+'_acal_a.fits'   
    dark1filename = strmid(allname, 0, allpos)+'_dark_1.fits'   
    dark2filename = strmid(allname, 0, allpos)+'_dark_2.fits'   
    dark3filename = strmid(allname, 0, allpos)+'_dark_3.fits'   
  endif else begin
    length = strlen(allname)
    objfilename = strmid(allname, 0, length-5)+'_obj.fits'
    mcalfilename = strmid(allname, 0, length-5)+'_mcal.fits'
    acalbfilename = strmid(allname, 0, length-5)+'_acal_b.fits'
    acalafilename = strmid(allname, 0, length-5)+'_acal_a.fits'
    dark1filename = strmid(allname, 0, length-5)+'_dark_1.fits'
    dark2filename = strmid(allname, 0, length-5)+'_dark_2.fits'
    dark3filename = strmid(allname, 0, length-5)+'_dark_3.fits'
  endelse

  packetid = mytsd -> Get_value_TSD('FIS_OBS', 'PACKETID')

  packetid_sed = 124L
  packetid_fr = 14L

;; mcal file

  if(keyword_set(nomcal) eq 0) then begin

    thres = 2e4
    tpcalft = mytsd -> Get_value_TSD('FIS_OBS', 'TpCalFT')

    ntpcalft = n_elements(tpcalft)

    shiftval = -10L  ;; 10 samping ΤΤ٤
    shift_tpcalft = shift(tpcalft, shiftval)

    calonindex = where((abs(tpcalft) ge thres) and (abs(shift_tpcalft) ge thres), ncalonindex)
    start_abovethres = calonindex[0]
  
    shiftval2 = -1L  ;; 1褬狼Ϥ
    shift_tpcalft2 = shift(tpcalft, shiftval2)
    caloffindex = where((abs(tpcalft[start_abovethres:ntpcalft-1L]) ge thres) and (abs(shift_tpcalft2[start_abovethres:ntpcalft-1L]) lt thres), ncaloffindex)
  
    endindex = caloffindex[0]+start_abovethres

    mposon = mytsd -> Get_status_TSD('FIS_OBS', 'MPosOn')
    startindex = (where(mposon eq 1))[0]

    nindex = endindex-startindex+1L

    subindex = lindgen(nindex)+startindex

    mcaltsd = mytsd -> Subset_TSD(subindex)

    dummy = mcaltsd -> Write_TSD(mcalfilename)

    obj_destroy, mcaltsd

    spawncommand = 'gzip '+mcalfilename
    spawn, spawncommand

  endif

;; obj file

  if(keyword_set(noobj) eq 0) then begin

    shutop = mytsd -> Get_status_TSD('FIS_OBS', 'SHTOP')

    shutopindex = where((shutop eq 1) and ((packetid eq packetid_sed) or (packetid eq packetid_fr)), nshutopindex)

;  tmpstart = shutopindex[0]
    endindex = shutopindex[nshutopindex-1L]

;  print, tmpstart, endindex

;  shutop_p = shutop[tmpstart:endindex]

;  shutcl_p = where(shutop_p eq 0, nshutcl_p)

;  if(nshutcl_p ge 100) then begin
;    print, 'too many blank? check the data'
;    stop
;  endif

;  startindex = shutcl_p[nshutcl_p-1L]+tmpstart+1L

    startindex = shutopindex[0]

;  print, startindex

    nindex = endindex-startindex+1L

;  print, nindex

    subindex = lindgen(nindex)+startindex

;  help, nindex, startindex
;  print, subindex[0], subindex[nindex-1]
;  help, subindex

    objtsd = mytsd -> Subset_TSD(subindex)

    dummy = objtsd -> Write_TSD(objfilename)

    obj_destroy, objtsd

    spawncommand = 'gzip '+objfilename
    spawn, spawncommand

  endif

;; acal file

  if(keyword_set(noacal) eq 0) then begin

    extrasample = 300L

    calon = mytsd -> Get_Status_TSD('FIS_OBS', 'CalALOn')
    aftime = mytsd -> Get_Value_TSD('FIS_OBS', 'AFTIME')

    calonstart = where((calon eq 1) and (shift(calon, 1) eq 0) and ((packetid eq packetid_sed) or (packetid eq packetid_fr)), ncalonstart)
    calonend = where((calon eq 1) and (shift(calon, -1) eq 0) and ((packetid eq packetid_sed) or (packetid eq packetid_fr)), ncalonend)

    if(ncalonstart ne ncalonend) then begin
      print, 'please check CalALOn status'
      return
    endif

    calperiod = aftime[calonend]-aftime[calonstart]
    usecal = where(calperiod ge 5.0, nusecal)

    if(nusecal ne 2) then begin
      print, 'the number of 1min cal is not 2'
      return
    endif

    usesample1 = indgen(calonend[usecal[0]]-calonstart[usecal[0]]+1L*extrasample*2L)+calonstart[usecal[0]]-extrasample
    usesample2 = indgen(calonend[usecal[1]]-calonstart[usecal[1]]+1L*extrasample*2L)+calonstart[usecal[1]]-extrasample

    acalbtsd = mytsd -> Subset_TSD(usesample1)
    acalatsd = mytsd -> Subset_TSD(usesample2)

    dummy = acalbtsd -> Write_TSD(acalbfilename)
    dummy = acalatsd -> Write_TSD(acalafilename)

    obj_destroy, acalbtsd
    obj_destroy, acalatsd

    spawncommand = 'gzip '+acalbfilename
    spawn, spawncommand

    spawncommand = 'gzip '+acalafilename
    spawn, spawncommand

  endif

;; dark file

  if(keyword_set(nodark) eq 0) then begin

    span = 20.0  ;; in sec
    datatype = mytsd->Get_Datatype()

    case datatype of
      'FIS_SW':itype = 0L
      'FIS_LW':itype = 1L
      else:message, 'datatype is wrong'
    endcase

    spansample = long(span*srate[itype])

;; dark_1 (ref. mcal)

    thres = 2e4
    tpcalft = mytsd -> Get_value_TSD('FIS_OBS', 'TpCalFT')

    ntpcalft = n_elements(tpcalft)

    shiftval = -10L  ;; 10 samping ΤΤ٤
    shift_tpcalft = shift(tpcalft, shiftval)

    calonindex = where((abs(tpcalft) ge thres) and (abs(shift_tpcalft) ge thres), ncalonindex)
    endindex1 = calonindex[0]-long(1.0*srate[itype])  ;; mcal Ϥ1

    startindex1 = endindex1-spansample+1L

    usesample1 = indgen(spansample)+startindex1

;; dark_2 (ref. obj)

    shutop = mytsd -> Get_status_TSD('FIS_OBS', 'SHTOP')

    shutopindex = where((shutop eq 1) and ((packetid eq packetid_sed) or (packetid eq packetid_fr)), nshutopindex)

    endindex2 = shutopindex[0]-long(1.0*srate[itype]) ;; obj Ϥ1

    startindex2 = endindex2-spansample+1L

    usesample2 = indgen(spansample)+startindex2

;; dark_3 

    startindex3 = shutopindex[nshutopindex-1L]+long(3.0*srate[itype]) ;; objλ3ø
    usesample3 = indgen(spansample)+startindex3

    dark1tsd = mytsd -> Subset_TSD(usesample1)
    dark2tsd = mytsd -> Subset_TSD(usesample2)
    dark3tsd = mytsd -> Subset_TSD(usesample3)

    dummy = dark1tsd -> Write_TSD(dark1filename)
    dummy = dark2tsd -> Write_TSD(dark2filename)
    dummy = dark3tsd -> Write_TSD(dark3filename)

    obj_destroy, dark1tsd
    obj_destroy, dark2tsd
    obj_destroy, dark3tsd

    spawncommand = 'gzip '+dark1filename
    spawn, spawncommand

    spawncommand = 'gzip '+dark2filename
    spawn, spawncommand

    spawncommand = 'gzip '+dark3filename
    spawn, spawncommand

  endif

  obj_destroy, mytsd

end
