PRO fts_radec, $
  filename, $
  ra, $
  dec, $
  averadec, $
  AOCU_ADS = aocu_ads

;; read tsd, convert to volt unit, get parameters

tsd=OBJ_NEW('tsd')
ret=tsd->Read_TSD(filename)
data_type = tsd->Get_Datatype()

; get AOCS data - Q parameter

if keyword_set(AOCU_ADS) then begin
        q = tsd->get_value_tsd('AOCU','AOCU_ADS_Q')
        print, 'Attitude data: AOCU_ADS_Q'
endif else begin
        q = tsd->get_value_tsd('GADS','ATTITUDE')
        print, 'Attitude data: GADS'
endelse

; calculate pixel position in RADEC and draw image of ea/ch array column

        root = GETENV('FISDR_ROOT')
 
        if(data_type eq 'FIS_SW') then begin
;            pix_pos_file =root+'/fts/tools/fts_sw_pos.dat'
            pix_pos_file = root+'/slowscan/lib/FIS-SW_pix_pos_distort1.dat'
           npix = 100
        endif else begin
;            pix_pos_file =root+'/fts/tools/fts_lw_pos.dat'
            pix_pos_file =root+'/slowscan/lib/FIS-LW_pix_pos_distort1.dat'
            npix = 75
        endelse

;    ss_q_to_radec, q, data_type, pix_pos_file, ra, dec
    ss_q_to_radec, q, data_type, pix_pos_file, ra, dec, /fts

;average RA,DEC

averadec = dblarr(2, npix)

for ch = 0, npix-1 do begin
   mora = moment(ra[ch, *])
   modec = moment(dec[ch, *])
   averadec[0, ch] = mora[0]
   averadec[1, ch] = modec[0]
endfor

wp = indgen(npix*3/5)

plot,(averadec[0,wp]),(averadec[1,wp]),psym=-2,$
   yrange = [min(averadec[1, wp]), max(averadec[1, wp])], $
   xticklen = 1, yticklen = 1, xgridstyle = 1, ygridstyle = 1
xyouts,averadec[0,0],averadec[1,0],'ch.1',charsize=2,color='FFFF00'XL
 plots,[148.97],[69.680],color='FF00FF'XL,psym=2 ;;M82

if(data_type eq 'FIS_SW') then begin
  print,'RA', (averadec[0,29]+averadec[0,30])/2
  print, 'DEC', (averadec[1,29]+averadec[1,30])/2
endif else if(data_type eq 'FIS_LW') then begin
  print,'RA', (averadec[0,31]+averadec[0,51])/2
  print, 'DEC', (averadec[1,31]+averadec[1,51])/2
endif

MESSAGE,'FINISH.',/continue
end
