PRO fts_radec2, $
  filename, $
  radec, $
  AOCU_ADS = aocu_ads, $
  tsd = tsd


;; read tsd, convert to volt unit, get parameters
if (keyword_set(tsd) ne 1) then begin
   print, filename
   tsd=OBJ_NEW('tsd')
   ret=tsd->Read_TSD(filename)
 endif 

data_type = tsd->Get_Datatype()

; get AOCS data - Q parameter

if keyword_set(AOCU_ADS) then begin
        q = tsd->get_value_tsd('AOCU','AOCU_ADS_Q')
        print, 'Attitude data: AOCU_ADS_Q'
endif else begin
        q = tsd->get_value_tsd('GADS','ATTITUDE')
        print, 'Attitude data: GADS'
      endelse

;; average q

qa = dblarr(4)
for n = 0, 3 do begin
mom = moment(q[n, *])
qa[n] = mom[0]
endfor

; calculate pixel position in RADEC and draw image of each array column

        root = GETENV('FISDR_ROOT')
 
        if(data_type eq 'FIS_SW') then begin
;            pix_pos_file =root+'/fts/tools/fts_sw_pos.dat'
            pix_pos_file =root+'/slowscan/lib/FIS-SW_pix_pos_distort1.dat'
            npix = 100
        endif else begin
;            pix_pos_file =root+'/fts/tools/fts_lw_pos.dat'
            pix_pos_file =root+'/slowscan/lib/FIS-LW_pix_pos_distort1.dat'
            npix = 75
        endelse

;    ss_q_to_radec, qa, data_type, pix_pos_file, ra, dec
    ss_q_to_radec, qa, data_type, pix_pos_file, ra, dec, /fts
radec = dblarr(2, npix)
radec[0, *] = ra
radec[1, *] = dec
wp = indgen(npix*3/5)

plot,(radec[0,wp]),(radec[1,wp]),psym=-2,$
   yrange = [min(radec[1, wp]), max(radec[1, wp])], $
   xticklen = 1, yticklen = 1, xgridstyle = 1, ygridstyle = 1
xyouts,radec[0,0],radec[1,0],'ch.1',charsize=2,color='FFFF00'XL
 plots,[148.97],[69.680],color='FF00FF'XL,psym=2 ;;M82

if(data_type eq 'FIS_SW') then begin
  print,'RA', (radec[0,29]+radec[0,30])/2
  print, 'DEC', (radec[1,29]+radec[1,30])/2
endif else if(data_type eq 'FIS_LW') then begin
  print,'RA', (radec[0,31]+radec[0,51])/2
  print, 'DEC', (radec[1,31]+radec[1,51])/2
endif

MESSAGE,'FINISH.',/continue
end
