pro plot_phase, x, ampcos, ampsin, color=color, line=line, psym=psym, $
		yrange=yrange, oplot=oplt, ninter=ninter, _extra=_extra

if ( keyword_set( oplt ) ) then yr = !y.range $
else if ( n_elements( yrange ) EQ 2 ) then yr = yrange $
else yr = [-1,1]

if ( n_elements( psym  ) EQ 2 ) then ps = psym	else ps=[1,1]
if ( n_elements( color ) EQ 2 ) then cl = color else cl=[1,14]

if ( n_elements( ninter ) EQ 0 ) then ninter = 5

phs = atan( ampsin, ampcos )				; phase

npt = n_elements( x )
if ( npt EQ 1 ) then begin				; only one point
    if ( ispresent( ampcos GE 0, b ) ) then $
	oplot, [x[b]], [sin( phs[b] )], ps=ps[0], color=cl[0], _extra=_extra
    if ( ispresent( ampcos LT 0, b ) ) then $
	oplot, [x[b]], [sin( phs[b] )], ps=ps[1], color=cl[1], _extra=_extra
    return
endif

mpt = ( ninter + 1 ) * ( npt - 1 ) + 1
step = 1.0 / ( ninter + 1 )

xm = fltarr( mpt )
dx = ( shift( x, -1 ) - x )[0:npt-2]
xx = x[0:npt-2]

pm = fltarr( mpt )
dp = shift( phs, -1 ) - phs
if ( ispresent( dp GT !PI, b ) ) then dp[b] -=	2 * !PI
if ( ispresent( dp LT (-!PI), b ) ) then dp[b] += 2 * !PI
pp = phs[0:npt-2]

bb = lindgen( npt - 1 ) * ( ninter + 1 )
for k = 0, ninter do begin
    xm[bb] = xx + dx * k * step
    pm[bb] = pp + dp * k * step
    bb = bb + 1
endfor
xm[mpt-1] = x[npt-1]				    ; last one
pm[mpt-1] = phs[npt-1]

sm = sin( pm )
cm = cos( pm )

if ( NOT keyword_set( oplt ) ) then $
    plot, cliprange( x ), yr, /nodata, _extra=_extra

if ( ispresent( cm GE 0, b ) ) then $
    oplot, xm[b], sm[b], ps=3, color=cl[0], _extra=_extra
if ( ispresent( cm LT 0, b ) ) then $
    oplot, xm[b], sm[b], ps=3, color=cl[1], _extra=_extra
if ( ispresent( ampcos GE 0, b ) ) then $
    oplot, x[b], sin( phs[b] ), ps=ps[0], color=cl[0], _extra=_extra
if ( ispresent( ampcos LT 0, b ) ) then $
    oplot, x[b], sin( phs[b] ), ps=ps[1], color=cl[1], _extra=_extra

end
