pro plotmodel, model0, flags, xr=xr, _extra=_extra

compile_opt idl2

model = model0
sz = size( model )
nl = sz[1]
ns = sz[2]

if ( n_elements( flags ) GT 0 ) then begin
  flg = bytarr( nl, ns )
  s2 = size( flags )
  nreduce = s2[1] / nl
  br = indgen( nreduce )
  for k = 0, nl-1 do begin
    flg[k] = total( flags[br,*], 1 ) EQ nreduce
    br += nreduce
  endfor
endif

b = where( flg GT 0, nb )
if ( nb GT 0 ) then model[b] = !values.f_nan

xs = 0.1
dx = 0.8 / nl
yr = cliprange( model, xrange=xr )
yr = 0.5 * ( yr - reverse( yr ) )		    ; symmetrize
mx = 1.05 * ( xr[1] - xr[0] ) + xr[0]
xtitle = "Samples"
title = ''
noerase = 0
for k = 0, nl-1 do begin
    if ( k EQ nl-1 ) then title = "Periodic Noise Model"
    plot, model[k,*], position=[0.1,xs,0.9,xs+dx], xtitle=xtitle, $
	xtickname=xtickname, yminor=0, yticks=2, xrange=xr, _extra=_extra, $
	noerase=noerase, yrange=yr, yst=1, title= title
    xyouts, mx, 0, string( "row", k+1, format='(a,i2)' )
    xtitle = ""
    xtickname = replicate( ' ', 10 )
    xs += dx
    noerase = 1
endfor

end
