;#> append.dc1
; Identifier	append
;
; Purpose	append an item to an array of the same
;
; Synopsis	result = append( x, y, /new )
;
; Arguments	Name	I/O    Type:	Description
;		------------------------------------------------------------
;		x	 I     any(arr)
;		y	 I     any
;		new	 I     keyword	if set force start of new array
;
; Returns	result	 O     any(arr)
;
; Description	appends an item to an array of the same items or if empty
;		( or /new ) starts an array of the same
;
;
;
; Comment
;
;
; Example	To append a parameter 10.0 to a (maybe empty list of)
;		parameters
;		    par = append( par, 10.0 )
;
; Category	UTIL ( module: append )
;
; Filename	append.pro
;
; Author	Do Kester
;
; Version	1.1
;
; History	1.0  21-03-2001 DK, first implementation of append.pro
;		1.1  16-05-2001 DK, add keyword NEW
;#<
;===========================================================================

function append, x, y, new=new

return, ( keyword_set( new ) OR n_elements( x ) EQ 0 ) ? $
	y : [ temporary( x ), y ]
end
