
function neighbor_pixels, ch, detector, $
	searching_width = searching_width, $
	all_bands = all_bands, $
	ignore_range = ignore_range

if (not keyword_set(searching_width)) then $
	searching_width = 1
searching_width = double(searching_width)

if (ch le 0) then begin
	lmessage, 5, 'Specified channel is out of range.'
	return, -1
endif

if (detector eq 'SW') then begin
	if (ch gt 100) then begin
		lmessage, 5, 'Specified channel is out of range.'
		return, -1
	endif
	row = 20
endif else begin
	if (ch gt 75) then begin
		lmessage, 5, 'Specified channel is out of range.'
		return, -1
	endif
	row = 15
endelse

theta = 26.565051D		;in degree
TO_RAD = !DPI/180D

; determine the pixel position in the detector array
; ------------------------------
xpos = (dindgen(row)+1D) # replicate(1.0D, 5)
ypos = replicate(1.0D, row) # (dindgen(5)+1D)
x0 = xpos[ch-1]
y0 = ypos[ch-1]

xi = 1D/( tan(theta*TO_RAD) + tan((90D - theta)*TO_RAD) ) * $
	( x0*tan((90D - theta)*TO_RAD) + xpos*tan(theta*TO_RAD) - y0 + ypos )

yi = -1.0d * tan(theta*TO_RAD) / $
	( tan(theta*TO_RAD) + tan((90D - theta)*TO_RAD) ) * $
	( (x0 - xpos)*tan((90D - theta)*TO_RAD) - y0 + ypos ) + ypos

distance = sqrt((xpos - xi)^2 + (ypos - yi)^2)
neighbor = where(distance le 0.447214d * searching_width) + 1

if (keyword_set(all_bands)) then begin
	index = where(neighbor ne ch)
endif else begin
	if (ch le row * 3D) then $
		index = where(neighbor ne ch and neighbor le row * 3D) $
	else $
		index = where(neighbor ne ch and neighbor gt row * 3D)
endelse

neighbor = neighbor[index]

if (keyword_set(ignore_range)) then begin
	distance = sqrt((xpos - x0)^2 + (ypos - y0)^2)
	ignore_pix = where(distance le double(ignore_range)*sqrt(2D), count) + 1

	if (count ne 0) then begin
		for i = 0, n_elements(ignore_pix)-1 do begin
			index = where(neighbor eq ignore_pix[i], count)
			if (count ne 0) then neighbor[index] = -1
		endfor

		index2 = where(neighbor ne -1, count)
		if (count ne 0) then neighbor = neighbor[index2] else neighbor = -1
	endif

endif

return, neighbor

end

