
function pixel_separation_inscan, ch1, ch2, detector

if (ch1 le 0 or ch2 le 0) then begin
	lmessage, 5, 'Specified channel is out of range.'
	return, -1
endif

if (detector eq 'SW') then begin
	if (ch1 gt 100 or ch2 gt 100) then begin
		lmessage, 5, 'Specified channel is out of range.'
		return, -1
	endif
	row = 20
	pitch = 26.8D / 3600.0D
endif else begin
	if (ch1 gt 75 or ch2 gt 75) then begin
		lmessage, 5, 'Specified channel is out of range.'
		return, -1
	endif
	row = 15
	pitch = 44.2D / 3600.0D
endelse

theta = 26.565051D		;in degree
TO_RAD = !DPI/180D

; determine the pixel position in the detector array
; ------------------------------
xpos = (dindgen(row)+1D) # replicate(1.0D, 5)
ypos = replicate(1.0D, row) # (dindgen(5)+1D)
x0 = xpos[ch1-1]
y0 = ypos[ch1-1]
x1 = xpos[ch2-1]
y1 = ypos[ch2-1]

xi = 1D/( tan(theta*TO_RAD) + tan((90D - theta)*TO_RAD) ) * $
	( x0*tan((90D - theta)*TO_RAD) + x1*tan(theta*TO_RAD) - y0 + y1 )

yi = -1.0d * tan(theta*TO_RAD) / $
	( tan(theta*TO_RAD) + tan((90D - theta)*TO_RAD) ) * $
	( (x0 - x1)*tan((90D - theta)*TO_RAD) - y0 + y1 ) + y1

distance = sqrt((x0 - xi)^2 + (y0 - yi)^2)

return, distance * pitch

end


