Pro write_caltable, A, acomment, flnm, OBS_START=obs_start, OBS_END=obs_end, BB_STRENGTH=bbstr, BB_START=bbsdate, BB_END=bbedate, RESET=rst, DTBB=dtbb, BB_From=bb_from
;+
; NAME: WRITE_CALTABLE
;
; PURPOSE:
;
; CATEGORY: ASTRO-F/FIS
;
; CALLING SEQUENCE:
;
; INPUTS:
;
;
;
; OPTIONAL INPUTS:
;
;
;
; KEYWORD PARAMETERS:
;
;
;
; OUTPUTS:
;
;
;
; OPTIONAL OUTPUTS:
;
;
;
; COMMON BLOCKS:
;
;
;
; SIDE EFFECTS:
;
;
;
; RESTRICTIONS:
;
;
;
; PROCEDURE:
;
;
;
; EXAMPLE:
;
;
;
; MODIFICATION HISTORY:
;	27-Mar-2006     SangHoon Oh
;	Imported from GB_MAKE_DC_CAL_TABLE (Dr. Makiuti's)
;-

  ;; Create the primary header

  ; Find Time Stamp
  CALDAT, SYSTIME(/JULIAN, /UTC), mm, dd, yy, hh, ms, ss
  cdate = STRING(FORMAT='(I4.4,"-",I2.2,"-",I2.2,"T",I2.2,":",I2.2,":",I2.2)', $
            yy, mm, dd, hh, ms, ss, /PRINT)

  FXHMAKE,  header, /initialize, /extend, /date
  FXADDPAR, header, 'ORIGIN',   'ISAS/JAXA',    'Organization creating FITS file'
  FXADDPAR, header, 'DATE',     cdate,          'Date of data creation'
  FXADDPAR, header, 'DATATYPE', 'FIS CAL ',     'Data Type'
  FXADDPAR, header, 'TELESCOP', 'ASTRO-F ',     'ASTRO-F mission'
  FXADDPAR, header, 'INSTRUME', 'FIS     ',     'FIS'
  FXADDPAR, header, 'CREATOR',  'PV_CALTAB_BB', 'Procedure which extracts Calibration table after bias boost for PV'
  FXADDPAR, header, 'COMMENT',  '## FIS DC_CAL_LAMP TABLE ##', ''

  FXWRITE, flnm, header

  ;; Create the CAL extention header and write it

  sz_cal = size(A)

  FXBHMAKE, bhdcal, sz_cal[1], 'CAL',                 'Extension name'
  FXADDPAR, bhdcal, 'EXTVER',  '1',                   'Extension version (must be an integer)'
  FXADDPAR, bhdcal, 'TIMESYS', 'UTC',                 'Explicit time scale specification'
  FXADDPAR, bhdcal, 'DATE-OBS', obs_start, 'Date of calibration signal start'
  FXADDPAR, bhdcal, 'DATE-END', obs_end, 'Date of calibration signal end'
  FXADDPAR, bhdcal, 'TIME-BBS', bbsdate, 'Time of Bias Boost Start'
  FXADDPAR, bhdcal, 'TIME-BBE', bbedate, 'Time of Bias Boost End'
  FXADDPAR, bhdcal, 'STRENGTH', bbstr, 'Strength of Bias Boost'
  FXADDPAR, bhdcal, 'DURATION', dtbb, 'Second. Duration of Bias Boost'
  FXADDPAR, bhdcal, 'BB_FROM', bb_from, 'Original TSD file from which bias boost information came'  
  FXADDPAR, bhdcal, 'RESET', rst, 'Reset'
  FXADDPAR, bhdcal, 'COMMENT', '', ''
  FXADDPAR, bhdcal, 'COMMENT', 'Extracted from FIS observation packet', ''
  FXADDPAR, bhdcal, 'COMMENT', acomment,  ''
  FXADDPAR, bhdcal, 'COMMENT', '', ''

  FXBADDCOL, iAFTIME,     bhdcal, 0D,  'AFTIME',     'ASTRO-F satellite time',  TUNIT = 'sec'
  FXBADDCOL, iFLUX,       bhdcal, 0E,  'FLUX',       'FIS CAL data'
  FXBADDCOL, iERR,        bhdcal, 0E,  'ERR',        'Error of CAL flux'
  FXBADDCOL, iSHUTOPEN,   bhdcal, 0B,  'SHUTOPEN',   'Shutter Open/Close'
  FXBADDCOL, iBAD,        bhdcal, 0B,  'BAD',        'Bad ON/OFF'
  FXBADDCOL, iDAC,        bhdcal, 0B,  'CALADAC',    'CalA DAC set value'

  MWRFITS, A, flnm, bhdcal, /NO_COMMENT

  return

End
