' Copyright(C) 2007, ASTRO-F Data Reduction Team.  All rights reserved.
'
'+
' NAME:
'   win_fisdr
'
' PURPOSE:
'   Start-up fisdr IDL session on Windows environement. Written in Visual Basic script.
'
' CATEGORY:
'   Data definition
'
' CALLING SEQUENCE:
'   Click the icon
'
' INPUTS:
'   None
'
' OUTPUTS:
'   None
'
' RESTRICTIONS:
'   None
'
' COMMENTS:
'   Not tested broadly.
'   Users may see security warning but that can be ignored.
'
' DESCRIPTION:
'   Setup proper environemnt variable and startup IDL for the fisdr session.
'
' EXAMPLE:
'   None
'
' SIDE EFFECTS:
'   None
'
' REFERENCE:
'   None
'
' MODIFICATION HISTORY:
'   Version 1.0  2007/09/11 S. Makiuti and I. Yamamura
'
'
' ==================================================================
'  Please edit the following line to point the directory where you
'  locate the toolkit.
' ==================================================================

fisdr_root = "C:\Documents and Settings\astrof\ASTRO-F\reduction\"

' ==================================================================
'   DO NOT EDIT THE FOLLOWING LINES
' ==================================================================

' Initialization

Set ws = WScript.CreateObject("WScript.Shell")

Set EnvList = ws.Environment("PROCESS")

' ------------------------------------------------------------------
'  Set up environment variables for FISDR

EnvList("FISDR_ROOT")=fisdr_root

EnvList("IDL_STARTUP")=EnvList("FISDR_ROOT")+"\startup\pro\startup_fisdr.pro"

' ------------------------------------------------------------------
' Start IDL

ws.run "idlde.exe"

' === End of script
