; Copyright(C) 2005, ASTRO-F Data Reduction Team.  All rights reserved.
;
;+
; NAME:
;   startup_fisdr
;
; PURPOSE:
;   Initialize IDL environment for FIS Data Reduction automatically.
;
; CATEGORY:
;   Startup script
;
; CALLING SEQUENCE:
;   @startup_fisdr
;
; INPUTS:
;   None
;
; OUTPUTS:
;   None
;
; RESTRICTIONS:
;   None
;
; COMMENTS:
;   None
;
; DESCRIPTION:
;   Excecute fisdr.pro startup file at the IDL session opening.
;   This module is expected to be called from fisdr startup script.
;
; EXAMPLE:
;   None
;
; SIDE EFFECTS:
;   None
;
; REFERENCE:
;   None
;
; MODIFICATION HISTORY:
;   Version 1.0   2005/06/08 IY First draft
;           1.1   2007/08/21 IY Enable to execute IDL command from command line
;           1.2   2007/09/09 IY The file can be used as IDL startup file
;           1.3   2007/09/11 IY Should work stably in Unix/Windows
;                            IY Clean up batch bly in Unix/Windows
;           1.3.1 2007/09/11 IY Bug fix to keep compatibility on Unix/Windows
;           1.3.2 2007/09/11 IY Further minor correction.
;
;-
;
; ==================================================================
; DO NOT CHANGE THE SETUP BELOW
; ==================================================================
; FISDR internal setup script. This may overridge the users setup.

; Set IDL path to call fisdr. !PATH will be reset again in fisdr

!PATH = EXPAND_PATH('+' + GETENV('FISDR_ROOT')) + $
  ':' + EXPAND_PATH(PREF_GET('IDL_PATH')) + $
  ':' + EXPAND_PATH('<IDL_DEFAULT>')

; fisdr environment setup
fisdr

; ------------------------------------------------------------------
; execute FISDR commands specified in the command line

com = STRJOIN(COMMAND_LINE_ARGS())
ret = EXECUTE(com)
if (STRLEN(com) GT 0) then exit
DELVAR, com, ret

; ==================================================================
