FUNCTION y_Concat_Ramps, ramp1, ramp2
; 05/01/07 I.Yamamura
; concatinate two ramp data [nsmpl, nramp, ndet]
; concatinated ramp data has nsmpl of the larger one and nramp of
; sum of two input nramp

; check dimensions
   r_dim1 = size(ramp1, /DIMENSIONS)
   if (n_elements(r_dim1) NE 3) then begin
      MESSAGE, 'Incorrect ramp dimension of ramp1 (expect [nsmpl, nramp, ndet]).'+STRING(r_dim1,/PRINT), /CONTINUE
      return, 0
   endif
   nsmpl1 = r_dim1[0]
   nramp1 = r_dim1[1]
   ndet1  = r_dim1[2]

   r_dim2 = size(ramp2, /DIMENSIONS)
   if (n_elements(r_dim2) NE 3) then begin
      MESSAGE, 'Incorrect ramp dimension of ramp2 (expect [nsmpl, nramp, ndet]).'+STRING(r_dim2,/PRINT), /CONTINUE
      return, 0
   endif
   nsmpl2 = r_dim2[0]
   nramp2 = r_dim2[1]
   ndet2  = r_dim2[2]

; check if the ndet is same
   if (ndet1 NE ndet2) then begin
      MESSAGE, 'ndet inconsistent! ('+STRING(ndet1, /PRINT)+' <-> '+STRING(ndet2, /PRINT), /CONTINUE
      return, 0
   endif

; set dimension of ouput array
   nsmplo = max([nsmpl1, nsmpl2])
   nrampo = nramp1 + nramp2
   ndeto  = ndet1

; set BAD value
   BAD = y_bad_val_def()

; allocate memory for output array
   rampo = replicate(BAD, nsmplo, nrampo, ndeto)

; copy data from original array
   rampo[0:(nsmpl1-1), 0:(nramp1-1), *] = ramp1
   rampo[0:(nsmpl2-1), nramp1:(nrampo-1), *] = ramp2

   return, rampo
end
