FUNCTION y_Flag_Glitched_Ramps, ramp, LIMIT=limit, PLOTGR=plotgr
; 04/12/20 I.Yamamura
; 04/12/29 /PLOT implemented
; 05/01/01 renamed with 'y_'
;  fill the ramps which has glitch with BAD value
; 05/01/17 use y_bad_val_def()
; 05/02/14 xidx() -> y_xidx()
; 06/03/25 plot_ramp -> y_plot_ramp (remaining bug)
;
; ramp data: ramp[nsmpl, nramps, ndets]
; limit: threshould in sigma
; /PLOT: plot glitched ramps

if (n_elements(LIMIT) LE 0) then limit = 10D

BAD = y_bad_val_def()

r_dim = size(ramp, /DIMENSIONS)
if (n_elements(r_dim) NE 3) then begin
   MESSAGE, "Incorrect ramp dimension (expect [nsmpl, nramp, ndet])."+STRING(r_dim,/PRINT)
   return, ramp
endif
nsmpl = r_dim[0]
nramp = r_dim[1]
ndet  = r_dim[2]
ndata = nsmpl * nramp

dr = y_Diff_Ramp(ramp)
idxb = where (dr EQ BAD, cntb)

y_stat_ramp, dr, adr, sdr

adr = replicate(1D, ndata) # adr
sdr = replicate(1D, ndata) # sdr

ddr = reform(dr, ndata, ndet) - adr

if (cntb GT 0) then ddr[idxb] = 0

idx = where(abs(ddr) GT (sdr * limit), cnt)
if (cnt GT 0) then begin
   idx_det  = idx / ndata
   idx_sidx = idx MOD ndata
   idx_ramp = idx_sidx / nsmpl
   idx = idx_det * nramp + idx_ramp
   r = reform(ramp, nsmpl, nramp*ndet)
   r[*, idx] = BAD
   ramp_x = reform(r, nsmpl, nramp, ndet, /OVERWRITE)
   xx = y_xidx(ramp_x)

   print, "Flagged ramps are:"
   print, FORMAT='(A5,A5,A7,A8)', '#Det', '#Ramp', '#idx', 'Value'
   for i = 0, cnt-1 do begin
      print, FORMAT='(I5, I5, I7, E12.4)', idx_det[i]+1, idx_ramp[i], $
         idx_sidx[i], ddr[idx_sidx[i], idx_det[i]]
      if (keyword_set(PLOTGR)) then $
         y_plot_ramp, ramp[*, idx_ramp[i], idx_det[i]], psym=3, $
            TITLE='Det #'+STRTRIM(STRING(idx_det[i]+1),2)+', Sample: '+STRTRIM(STRING(idx_sidx[i]),2)
   endfor
endif else begin
   print, "No glitched ramp found."
   ramp_x = ramp
endelse

return, ramp_x
end
