FUNCTION y_Flag_RstAnom, ramp, LIMIT=limit, PLOTGR=plotgr
; 05/01/30 I.Yamamura created from y_Flag_Glitched_Ramps()
;
; ramp data: ramp[nsmpl, nramps, ndets]
; limit: threshould in sigma
; /PLOT: plot glitched ramps(not used)

if (n_elements(LIMIT) LE 0) then limit = 10D

BAD = y_bad_val_def()

r_dim = size(ramp, /DIMENSIONS)
if (n_elements(r_dim) NE 3) then begin
   MESSAGE, "Incorrect ramp dimension (expect [nsmpl, nramp, ndet])."+STRING(r_dim,/PRINT)
   return, ramp
endif
nsmpl = r_dim[0]
nramp = r_dim[1]
ndet  = r_dim[2]
ndata = nsmpl * nramp

rampx = ramp

for itop = 0, 2 do begin
   idx = where(rampx[itop, *, *] NE BAD, cnt)

   if (cnt GT 0) then begin
      idxa = array_indices(rampx[itop, *, *], idx)
      idxa[0, *] += itop

      idx = where(rampx[idxa[0, *]+1, idxa[1, *], idxa[2, *]] NE BAD, cnt)
      if (cnt EQ 0) then continue
      idxa = idxa[*, idx]

      idx = where(rampx[idxa[0, *]+2, idxa[1, *], idxa[2, *]] NE BAD, cnt)
      if (cnt EQ 0) then continue

      idxa = idxa[*, idx]

      dv1 = rampx[idxa[0, *]+1, idxa[1, *], idxa[2, *]] - $
            rampx[idxa[0, *], idxa[1, *], idxa[2, *]]
      dv2 = rampx[idxa[0, *]+2, idxa[1, *], idxa[2, *]] - $
            rampx[idxa[0, *]+1, idxa[1, *], idxa[2, *]]
      idx = where(abs(dv1) GT abs(dv2) * LIMIT, cnt)
      if (cnt GT 0) then begin
         rampx[idxa[0, idx], idxa[1, idx], idxa[2, idx]] = BAD
         MESSAGE, 'Automatic detect reset anomalies.', /CONTINUE
         for ic = 0, cnt-1 do begin
            print, FORMAT='(3I4, 2E10.2)', idxa[*, idx[ic]], abs(dv1[idx[ic]]), abs(dv2[idx[ic]])
         endfor
      endif

      break
   endif
endfor

return, rampx
end
