PRO y_Plot_all_Ramps, $
   ramp_x0,          $ ; X-axis data
   ramp_y0,          $ ; y-axis data (sould be consistent with ramp_x)
   TITLE=title,      $ ; additional title
   _EXTRA=extra        ; anything else
;
; 04/05/25 I.Yamamura
; 04/07/30 I.Yamamura add timestamp
; 05/01/02 renamed as 'y_'
; 05/02/14 xidx() -> y_xidx()

if ( n_params() EQ 1 ) then begin
   ramp_y = ramp_x0
   ramp_x = y_xidx(ramp_y)
endif else begin
   ramp_x = ramp_x0
   ramp_y = ramp_y0
endelse

r_dim = size(ramp_y, /DIMENSIONS)
if (n_elements(r_dim) NE 3) then begin
   MESSAGE, "Incorrect ramp dimension (expect [nsmpl, nramp, ndet])."+STRING(r_dim,/PRINT)
   return
endif
nsmpl = r_dim[0]
nramp = r_dim[1]
ndet  = r_dim[2]

if (ndet EQ 100) then begin
   np = 4
   nx = 20
endif else if (ndet EQ 75) then begin
   np = 3
   nx = 15
endif else begin
   MESSAGE, 'Invalid number of detectors ', ndet
endelse

for ip = 0, np-1 do begin
   erase
   for iy = 0, 4 do begin
      for ix = 0, 4 do begin
         !P.MULTI = [25 - iy*5 - ix, 5, 5]
         idet = ip * 5 + iy * nx + ix
         sdet = 'Det.# = '+STRTRIM(STRING(idet+1), 2)
         if (Keyword_set(TITLE)) then sdet = title + ' ' + sdet
         y_plot_ramp, ramp_x[*,*,idet], ramp_y[*,*,idet], $
            TITLE=sdet, _EXTRA = extra
      endfor
   endfor
   timestamp
endfor

!P.MULTI=[0,1,1]

end
