FUNCTION y_xidx, ramp
; 03/03/25 I.Yamamura
; 05/01/01 renamed with 'y_'
;
; generate X index corresponding to ramp

r_dim = size(ramp, /DIMENSIONS)
if (n_elements(r_dim) NE 3) then begin
   MESSAGE, "Incorrect ramp dimension (expect [nsmpl, nramp, ndet])."+STRING(r_dim,/PRINT)
   return, 0
endif
nsmpl = r_dim[0]
nramp = r_dim[1]
ndet  = r_dim[2]

xi = (indgen(nsmpl, nramp, ndet, /DOUBLE) MOD nsmpl)
return, xi
end
